
#addlang "russian"
#encoding system iso8859-1

putlog "-"
putlog "Beginning of a loading IRC-Arena core."
putlog "-"

set arenadir "scripts/mc/"
#if { ([string tolower $tcl_platform(platform)]=="unix"   ) } { if { [package ifneeded tbcload 1.3]=="" } { package ifneeded tbcload 1.3 [list load [file join libtbcload1.3.so]] }}
#if { ([string tolower $tcl_platform(platform)]=="windows") } { if { [package ifneeded tbcload 1.3]=="" } { package ifneeded tbcload 1.3 [list load [file join tbcload13.dll]] }}


proc mc:loadmodule {m} {
  global arenadir scriptfile; set m2 "${arenadir}mc.${m}."
  if { [file exist ${m2}tbc] } { set scriptfile ${m2}tbc } { set scriptfile ${m2}tcl }
  if {[catch {uplevel #0 {source $scriptfile}} errstr]} {
    putlog "Error while loading module <$m> \($errstr\)\r"
  }
}

mc:loadmodule misc

if { ![array exist mc] || ![info exist mc(phase)]} {
    set mc(cop) "IRC-Arena \[%s\]"

    set mc(phase) 0
    set mc(flags) ""

    set mc(alreadyhtml) 1

    set noreg 0
    cleartimers
    utimer 1 {
        mc:log "Maiden start - Auto-rehash"
        rehash
    }
}

set mc(gametype) 1

set mc(rules) "${arenadir}rules.txt"
set mc(file.base) "bots/arena.$network.$nick.base"
set mc(file.skil) "bots/arena.$network.$nick.skill"
set mc(file.coms) "bots/arena.$network.$nick.coms"
set mc(file.save) "bots/arena.$network.$nick.save"
set mc(file.drop) "bots/arena.$network.$nick.drop"
set mc(file.nexp) "bots/arena.$network.$nick.nexp"
set mc(file.bots) "bots/arena.$network.$nick.bots"
set mc(file.host) "bots/arena.$network.$nick.host"
set mc(file.conf) "bots/arena.$network.$nick.conf"
set mc(file.recs) "bots/arena.$network.$nick.records"
set mc(file.nlog) "bots/arena.$network.$nick.nlog"
set mc(file.phtml) "bots/arena.$network.$nick.players.stats"
set mc(file.chtml) "bots/arena.$network.$nick.coms.stats"

mc:loadmodule version
mc:loadmodule config
mc:loadmodule theme
mc:loadmodule utils
mc:loadmodule user
mc:loadmodule binds
mc:loadmodule reg
mc:loadmodule game
mc:loadmodule shop
mc:loadmodule round
mc:loadmodule rmisc
mc:loadmodule irc
mc:loadmodule com
mc:loadmodule ctools
mc:loadmodule twin
mc:loadmodule senna
mc:loadmodule hosts
mc:loadmodule telnet
mc:loadmodule poll
mc:loadmodule magic
mc:loadmodule skill
mc:loadmodule constants
mc:loadmodule esets
mc:loadmodule collect
mc:loadmodule talisman
mc:loadmodule spec
mc:loadmodule mode
mc:loadmodule html
mc:loadmodule savelist
mc:loadmodule transfer
mc:loadmodule weather
mc:loadmodule debug
mc:loadmodule update
mc:loadmodule admin

mc:loadmodule defconf

if { ![array exist mcs] } {
    mc:read
    mc:readrecords
    mc:calcaveragelevel
}

#source ${arenadir}mc.public.tcl
#source ${arenadir}mc.botnet.tcl
#source ${arenadir}mc.create.tcl
#source ${arenadir}mc.cskill.tcl
#source ${arenadir}mc.favor.tcl

#source ${arenadir}mc.total.server.tcl
#source ${arenadir}mc.total.client.tcl
#source ${arenadir}mc.total.theme.tcl

mc:config:load

# 㧪 ⥫ 㫥
foreach mod $mc(modules) {
  putlog "LOADING OF THE ADDITIONAL MODULE: $mod"
  mc:loadmodule x$mod
}

mc:prof:load

mc:update:init

#mc:skill:load
mc:shop:load
mc:weather:load
mc:magic:load
#warn! must be after shop loading.
mc:collect:load
mc:misc:loadresult

mc:binds:init
mc:telnet:init

putlog "-"
putlog "ArenaVer : $mc(ver)"
putlog "BotAdmin : $admin"
putlog "DropVer  : [lindex $version 0]"
putlog "-"
putlog "IRC-Arena is loaded."
putlog "-"
