
proc ms:fl {n} {
    regsub -all \\\\ $n !1 n
    regsub -all \\\[ $n !2 n
    regsub -all \\\] $n !3 n
    regsub -all \\\} $n !4 n
    regsub -all \\\{ $n !5 n
    regsub -all \\\^ $n !6 n
    regsub -all \\\" $n !7 n
#    regsub -all  $n !8 n
    return $n
}

proc ms:dfl {n} {
    regsub -all !1 $n \\ n
    regsub -all !2 $n \[ n
    regsub -all !3 $n \] n
    regsub -all !4 $n \} n
    regsub -all !5 $n \{ n
    regsub -all !6 $n \^ n
    regsub -all !7 $n \" n
#    regsub -all !8 $n  n
    return $n
}

proc usrsay {n t} {
    puthelp "NOTICE $n :$t"
}

proc tolower {str} {
    return [string tolower [string map {                                                                 } $str]]
}

proc isnumber {string} {
    if {([string compare "" $string]) && \
        (![regexp \[^0-9\] $string])} then {
        return 1
    }
    return 0
}

proc isrealnumber {string} {
    if {([string compare "" $string]) && \
        (![regexp "\[^0-9\.-\]" $string])} then {
        return 1
    }
    return 0
}

proc stripspec {s} {
    return [string map {\{ \\\{ \} \\\} \[ \\\[ \] \\\] \$ \\\$ \" \\\"} $s]
}

proc array_init {arrname} {
  upvar $arrname arr
  set arr(-) ""
  unset arr(-)
}

proc array_check {arrname index {def ""}} {
  upvar $arrname arr
  if { ![array exist arr] || ![info exist arr($index)] } { set arr($index) $def }
}

proc notice {n txt} {
  putserv "NOTICE $n :$txt"
}

proc echo str { putlog $str }

proc cl  {} { return "\[0m"    }
proc blk {} { return "\[0;30m" }
proc blu {} { return "\[0;34m" }
proc grn {} { return "\[0;32m" }
proc cyn {} { return "\[0;36m" }
proc red {} { return "\[0;31m" }
proc mag {} { return "\[0;35m" }
proc yel {} { return "\[0;33m" }
proc wht {} { return "\[0;37m" }

proc hblk {} { return "\[1;30m" }
proc hblu {} { return "\[1;34m" }
proc hgrn {} { return "\[1;32m" }
proc hcyn {} { return "\[1;36m" }
proc hred {} { return "\[1;31m" }
proc hmag {} { return "\[1;35m" }
proc hyel {} { return "\[1;33m" }
proc hwht {} { return "\[1;37m" }


set chpocktools 1
