
###############################################################################
#
#  .html 
#
#   (   ):
# = 0 --   ,   
# > 0 --      ,    
# < 0 --     ,    
#
###############################################################################

set html(ratings)    "${arenadir}ratings.html"
set html(ratings2)   "${arenadir}ratings2.html"
set html(tops)       "${arenadir}tops.html"
set html(p-ratings)  "ratings.html"
set html(p-ratings2) "ratings2.html"
set html(p-tops)     "tops.html"
set html(tablewidth) "98%"
set html(start) 0
set html(final) 0

proc mc:createstats {} {
    global network mc mcs mco html top basehref

    if { $network != "RusNet" } {
        return
    }

    mc:log "Creating players statistics..."

    set fid [open $mc(file.phtml) w]
    if { [array exists mcs] } {
        foreach id [array names mcs] {
            puts $fid "$id [mc:getstat nick $id] [mc:getstat race $id] [mc:getstat prof $id] [mc:getstat sex $id] [mc:getstat remort $id] [mc:getstat level $id] [mc:getstat exp $id] [mc:getstat game $id] [mc:getstat win $id] [mc:getstat ctime $id] [mc:getstat ltime $id] [mc:getstat run $id] [mc:getstat death $id]"
            puts $fid "[mc:getstat com $id]"
        }
    }
    close $fid

    set fid [open $mc(file.chtml) w]
    if { [array exists mco] } {
        foreach cid [array names mco] {
            puts $fid "$cid [mc:mcomget $cid 2] [mc:mcomget $cid 3] [mc:mcomget $cid 4] [mc:mcomget $cid 5] [mc:mcomget $cid 6]"
            set access ""
            foreach plr [mc:mcomget $cid 1] {
                lappend access "[lindex $plr 0].[lindex $plr 1]"
            }
            puts $fid "$access"
            puts $fid "[mc:mcomget $cid 0]"
        }
    }
    close $fid

    putlog "... complete"
}

proc mc:generatehtml {} {
    global mc mcs html top basehref

    mc:log "Generate HTML pages..."

    set html(start) [clock clicks]

    mc:topexp    0
    mc:topprof
    mc:toprace
    mc:topgame   20
    mc:topwin    20
    mc:topdeath  20
    mc:toprun    20
    mc:toplived  10
    mc:topnewbie 10
    mc:topteam

    set html(final) [clock clicks]

    set basehref(exp_team)   ""
    set basehref(prof_exp)   "$html(p-ratings)"
    set basehref(race_exp)   "$html(p-ratings)"
    set basehref(team_exp)   ""
    set basehref(game_exp)   "$html(p-ratings)"
    set basehref(win_exp)    "$html(p-ratings)"
    set basehref(death_exp)  "$html(p-ratings)"
    set basehref(run_exp)    "$html(p-ratings)"
    set basehref(lived_exp)  "$html(p-ratings)"
    set basehref(newbie_exp) "$html(p-ratings)"

    ### ------------------------------------------------------------------------------------------
    ###  1
    ### ------------------------------------------------------------------------------------------

    set fid [open $html(ratings) w]

    mc:htmlheader     $fid

    mc:htmlnewline    $fid
    mc:htmldate       $fid center
    mc:htmlnewline    $fid
    mc:htmlversion    $fid
    mc:htmlseparator  $fid

    mc:htmlcentero    $fid
    mc:htmlahref      $fid "$html(p-ratings)"          "<B>   </B>"
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-ratings)#topexp"   "    "
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-ratings)#topteam"  "  "
    mc:htmlnewline    $fid
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-ratings2)"         "<B>   </B>"
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-tops)"             "<B>,   </B>"
    mc:htmlcenterc    $fid
    mc:htmlseparator  $fid

    mc:htmlaname      $fid topexp
    mc:htmlnewline    $fid
    mc:htmltitle      $fid "   "
    mc:htmltopexp     $fid -200
    mc:htmlnewline    $fid

    mc:htmlseparator  $fid

    mc:htmlaname      $fid topteam
    mc:htmlnewline    $fid
    mc:htmltitle      $fid "  "
    mc:htmltopteam    $fid 0
    mc:htmlnewline    $fid
    mc:htmlseparator  $fid

    mc:htmlfooter     $fid

    close $fid

    ### ------------------------------------------------------------------------------------------
    ###  2
    ### ------------------------------------------------------------------------------------------

    set fid [open $html(ratings2) w]

    mc:htmlheader     $fid

    mc:htmlnewline    $fid
    mc:htmldate       $fid center
    mc:htmlnewline    $fid
    mc:htmlversion    $fid
    mc:htmlseparator  $fid

    mc:htmlcentero    $fid
    mc:htmlahref      $fid "$html(p-ratings)"          "<B>   </B>"
    mc:htmlnewline    $fid
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-ratings2)"         "<B>   </B>"
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-ratings2)#topprof" "    "
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-ratings2)#toprace" "    "
    mc:htmlnewline    $fid
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-tops)"             "<B>,   </B>"
    mc:htmlcenterc    $fid
    mc:htmlseparator  $fid

    mc:htmlaname      $fid topprof
    mc:htmlnewline    $fid
    mc:htmltitle      $fid "   "
    mc:htmltopprof    $fid -100
    mc:htmlnewline    $fid

    mc:htmlseparator  $fid

    mc:htmlaname      $fid toprace
    mc:htmlnewline    $fid
    mc:htmltitle      $fid "   "
    mc:htmltoprace    $fid -50
    mc:htmlnewline    $fid
    mc:htmlseparator  $fid

    mc:htmlfooter     $fid

    close $fid

    ### ------------------------------------------------------------------------------------------
    ### 
    ### ------------------------------------------------------------------------------------------

    set fid [open $html(tops) w]

    mc:htmlheader     $fid

    mc:htmlnewline    $fid
    mc:htmldate       $fid center
    mc:htmlnewline    $fid
    mc:htmlversion    $fid
    mc:htmlseparator  $fid

    mc:htmlcentero    $fid
    mc:htmlahref      $fid "$html(p-ratings)"          "<B>   </B>"
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-ratings2)"         "<B>   </B>"
    mc:htmlnewline    $fid
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-tops)"             "<B>,   </B>"
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-tops)#topgame"     "  "
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-tops)#topwin"      " "
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-tops)#topdeath"    " "
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-tops)#toprun"      " "
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-tops)#toplived"    " "
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-tops)#topnewbie"   " "
    mc:htmlnewline    $fid
    mc:htmlahref      $fid "$html(p-tops)#topremorts"  " "
   # mc:htmlnewline    $fid
   # mc:htmlahref      $fid "$html(p-tops)#toprecs"     " "

    mc:htmlcenterc    $fid
    mc:htmlseparator  $fid

    mc:htmlaname      $fid topgame
    mc:htmlnewline    $fid
    mc:htmltitle      $fid "  "
    mc:htmltopgame    $fid +10
    mc:htmlnewline    $fid

    mc:htmlaname      $fid topwin
    mc:htmlnewline    $fid
    mc:htmltitle      $fid "  "
    mc:htmltopwin     $fid +10
    mc:htmlnewline    $fid

    mc:htmlaname      $fid topdeath
    mc:htmlnewline    $fid
    mc:htmltitle      $fid "  "
    mc:htmltopdeath   $fid +10
    mc:htmlnewline    $fid

    mc:htmlaname      $fid toprun
    mc:htmlnewline    $fid
    mc:htmltitle      $fid "    "
    mc:htmltoprun     $fid +10
    mc:htmlnewline    $fid

    mc:htmlseparator  $fid

    mc:htmlaname      $fid toplived
    mc:htmlnewline    $fid
    mc:htmltitle      $fid "  "
    mc:htmltoplived   $fid +10
    mc:htmlnewline    $fid

    mc:htmlaname      $fid topnewbie
    mc:htmlnewline    $fid
    mc:htmltitle      $fid ""
    mc:htmltopnewbie  $fid +10
    mc:htmlnewline    $fid

    mc:htmlseparator  $fid

    mc:htmlaname      $fid topremorts
    mc:htmlnewline    $fid
    mc:htmltitle      $fid ""
    mc:htmlremorts    $fid
    mc:htmlnewline    $fid
    mc:htmlseparator  $fid

    #mc:htmlaname      $fid toprecs
    #mc:htmlnewline    $fid
    #mc:htmltitle      $fid ""
    #mc:htmlrecords    $fid
    #mc:htmlnewline    $fid
    #mc:htmlseparator  $fid

    mc:htmlfooter     $fid

    close $fid
}

proc mc:genhtml {} {
    global mc

    if {$mc(generatehtml) != 1} {
        return
    }

    if {$mc(alreadyhtml) != 1} {
        set mc(alreadyhtml) 1
#        mc:generatehtml
    }
}

bind time - "00 07 * * *" mc:switchhtml

proc mc:switchhtml {mi ho da mo ye} {
    global mc

    mc:log "Reset Switch HTML..."
    set mc(alreadyhtml) 0
}

proc mc:topexp {size} {
    global mcs mc top

    set top(exp) ""

    ###   

    for {set i 0} {$i < [array size mcs]} {incr i} {
        set temp ""
        set exp -1

        foreach id [array names mcs] {
            if {[lsearch -exact $top(exp) $id] != -1 || [mc:getstat exp $id] <= 0} { continue }
            if {$exp < [mc:getstat exp $id]} {
                set temp $id
                set exp [mc:getstat exp $id]
            }
        }

        set top(exp) [lappend top(exp) $temp]
    }
    set top(exp) [join $top(exp)]

    set topexp $top(exp)
    set top(exp) ""

    ###   

    for {set i 0} {$i < [llength $topexp]} {incr i} {
        if {$size > 0 && [llength $top(exp)] >= $size} { break }
        set temp ""
        set remort -1

        foreach id $topexp {
            if {[lsearch -exact $top(exp) $id] != -1} { continue }
            if {$remort < [mc:getstat remort $id]} {
                set temp $id
                set remort [mc:getstat remort $id]
            }
        }

        set top(exp) [lappend top(exp) $temp]
    }
    set top(exp) [join $top(exp)]

    #putlog "top(exp) = $top(exp)"
}

proc mc:topprof {} {
    global mcs mc top prof

    foreach p [split [mc:allprof] ""] {
        set top(prof$p) ""
    }

    if { ![info exists top(exp)] } { return }

    foreach id $top(exp) {
        set top(prof[mc:getstat prof $id]) [lappend top(prof[mc:getstat prof $id]) $id]
    }

    foreach p [split [mc:allprof] ""] {
        #putlog "top(prof$p) = $top(prof$p)"
    }
}

proc mc:toprace {} {
    global mcs mc top race

    foreach r [split [mc:allrace] ""] {
        set top(race$r) ""
    }

    if {![info exists top(exp)]} { return }

    foreach id $top(exp) {
        set top(race[mc:getstat race $id]) [lappend top(race[mc:getstat race $id]) $id]
    }

    foreach r [split [mc:allrace] ""] {
        #putlog "top(race$r) = $top(race$r)"
    }
}

proc mc:topteam {} {
    global mc mcs mco top

    set top(team) ""

    foreach cid [array names mco] {
        set comexp($cid) 0
        foreach e [mc:mcomget $cid 1] {
            if {[info exists mcs([lindex $e 0])] && [lindex $e 1] > 0} {
                incr comexp($cid) [mc:getstat exp [lindex $e 0]]
            }
        }
    }
    foreach cid [array names mco] {
        set comremort($cid) 0
        foreach e [mc:mcomget $cid 1] {
            if {[info exists mcs([lindex $e 0])] && [lindex $e 1] > 0} {
                incr comremort($cid) [mc:getstat remort [lindex $e 0]]
            }
        }
    }
    foreach cid [array names mco] {
        set comlevel($cid) 0
        foreach e [mc:mcomget $cid 1] {
            if {[info exists mcs([lindex $e 0])] && [lindex $e 1] > 0} {
                incr comlevel($cid) [mc:getstat level [lindex $e 0]]
            }
        }
    }

    ###   

    for {set i 0} {$i < [array size mco]} {incr i} {
        set temp ""
        set exp -1

        foreach cid [array names mco] {
            if {[lsearch -exact $top(team) $cid] != -1} { continue }
            if {$exp < $comexp($cid)} {
                set temp $cid
                set exp $comexp($cid)
            }
        }
        set top(team) [lappend top(team) $temp]
    }

    ###   

    set topteam $top(team)
    set top(team) ""

    for {set i 0} {$i < [llength $topteam]} {incr i} {
        set temp ""
        set remort -1

        foreach cid $topteam {
            if {[lsearch -exact $top(team) $cid] != -1} { continue }
            if {$remort < $comremort($cid)} {
                set temp $cid
                set remort $comremort($cid)
            }
        }
        set top(team) [lappend top(team) $temp]
    }

    ###   

    set topteam $top(team)
    set top(team) ""

    for {set i 0} {$i < [llength $topteam]} {incr i} {
        set temp ""
        set level -1

        foreach cid $topteam {
            if {[lsearch -exact $top(team) $cid] != -1} { continue }
            if {$level < $comlevel($cid)} {
                set temp $cid
                set level $comlevel($cid)
            }
        }
        set top(team) [lappend top(team) $temp]
    }

    #putlog "top(team) = $top(team)"
}

proc mc:topgame {size} {
    global mcs mc top

    set top(game) ""

    for {set i 0} {$i < [array size mcs]} {incr i} {
        if {$size > 0 && [llength $top(game)] >= $size} { break }
        set temp ""
        set game -1

        foreach id [array names mcs] {
            if {[lsearch -exact $top(game) $id] != -1 || [mc:getstat game $id] <= 0} { continue }
            if {$game < [mc:getstat game $id]} {
                set temp $id
                set game [mc:getstat game $id]
            }
        }

        set top(game) [lappend top(game) $temp]
    }
    # ..     ,    {}
    set top(game) [join $top(game)]

    #putlog "top(game) = $top(game)"
}

proc mc:topwin {size} {
    global mcs mc top

    set top(win) ""

    for {set i 0} {$i < [array size mcs]} {incr i} {
        if {$size > 0 && [llength $top(win)] >= $size} { break }
        set temp ""
        set win -1

        foreach id [array names mcs] {
            if {[lsearch -exact $top(win) $id] != -1 || [mc:getstat win $id] <= 0} { continue }
            if {$win < [mc:getstat win $id]} {
                set temp $id
                set win [mc:getstat win $id]
            }
        }

        set top(win) [lappend top(win) $temp]
    }
    # ..     ,    {}
    set top(win) [join $top(win)]

    #putlog "top(win) = $top(win)"
}

proc mc:topdeath {size} {
    global mcs mc top

    set top(death) ""

    for {set i 0} {$i < [array size mcs]} {incr i} {
        if {$size > 0 && [llength $top(death)] >= $size} { break }
        set temp ""
        set death -1

        foreach id [array names mcs] {
            if {[lsearch -exact $top(death) $id] != -1 || [mc:getstat death $id] <= 0} { continue }
            if {$death < [mc:getstat death $id]} {
                set temp $id
                set death [mc:getstat death $id]
            }
        }

        set top(death) [lappend top(death) $temp]
    }
    # ..     ,    {}
    set top(death) [join $top(death)]

    #putlog "top(death) = $top(death)"
}

proc mc:toprun {size} {
    global mcs mc top

    set top(run) ""

    for {set i 0} {$i < [array size mcs]} {incr i} {
        if {$size > 0 && [llength $top(run)] >= $size} { break }
        set temp ""
        set run -1

        foreach id [array names mcs] {
            if {[lsearch -exact $top(run) $id] != -1 || [mc:getstat run $id] <= 0} { continue }
            if {$run < [mc:getstat run $id]} {
                set temp $id
                set run [mc:getstat run $id]
            }
        }

        set top(run) [lappend top(run) $temp]
    }
    # ..     ,    {}
    set top(run) [join $top(run)]

    #putlog "top(run) = $top(run)"
}

proc mc:toplived {size} {
    global mcs mc top

    set top(lived) ""

    for {set i 0} {$i < [array size mcs]} {incr i} {
        if {$size > 0 && [llength $top(lived)] >= $size} { break }
        set temp ""
        set lived -1

        foreach id [array names mcs] {
            if {[lsearch -exact $top(lived) $id] != -1 || [mc:getstat ltime $id] == 0 || [expr [clock seconds] - [mc:getstat ctime $id]] <= 86400} { continue }

            if {$lived < [expr [clock seconds] - [mc:getstat ctime $id]]} {
                set temp $id
                set lived [expr [clock seconds] - [mc:getstat ctime $id]]
            }
        }

        set top(lived) [lappend top(lived) $temp]
    }
    set top(lived) [join $top(lived)]

    #putlog "top(lived) = $top(lived)"
}

proc mc:topnewbie {size} {
    global mcs mc top

    set top(newbie) ""

    for { set i 0 } { $i < [array size mcs] } { incr i } {
        if { $size > 0 && [llength $top(newbie)] >= $size } { break }
        set temp ""
        set newbie -1

        foreach id [array names mcs] {
            if { [lsearch -exact $top(newbie) $id] != -1 || [mc:getstat ltime $id] == 0 || [expr [clock seconds] - [mc:getstat ctime $id]] <= 86400 } { continue }

            if { $newbie > [expr [clock seconds] - [mc:getstat ctime $id]] || $newbie == -1 } {
                set temp $id
                set newbie [expr [clock seconds] - [mc:getstat ctime $id]]
            }
        }

        set top(newbie) [lappend top(newbie) $temp]
    }
    set top(newbie) [join $top(newbie)]

    #putlog "top(newbie) = $top(newbie)"
}

### ----------------------------------------------------------------------------------------------------
### ----------------------------------------------------------------------------------------------------
### ----------------------------------------------------------------------------------------------------

proc mc:htmlchars {string} {
    regsub -all "<" $string "\\\&lt;" string
    regsub -all ">" $string "\\\&gt;" string
    regsub -all \"  $string "\\\&quote;" string
    return $string
}

proc mc:htmlspace {string} {
    regsub -all "\[\[:space:\]\]" $string "\\\&nbsp;" string
    return $string
}

proc mc:htmlcomname {string} {
    regsub -all "\[\[:space:\]\]" $string "\\\&nbsp;" string

    regsub -all !1 $string \\ string
    regsub -all !2 $string \[ string
    regsub -all !3 $string \] string
    regsub -all !4 $string \} string
    regsub -all !5 $string \{ string
    regsub -all !6 $string \^ string
    regsub -all !7 $string \" string

    # colors
    regsub -all "(\[\[:digit:\]\]{1,2}),(\[\[:digit:\]\]{1,2})" $string "</SPAN><SPAN STYLE=\"color:\\1; background-color:\\2;\">" string
    regsub -all "(\[\[:digit:\]\]{1,2})" $string "</SPAN><SPAN STYLE=\"color:\\1;\">" string
    regsub -all "color:0;"  $string "color:white;"   string
    regsub -all "color:1;"  $string "color:black;"   string
    regsub -all "color:2;"  $string "color:navy;"    string
    regsub -all "color:3;"  $string "color:green;"   string
    regsub -all "color:4;"  $string "color:red;"     string
    regsub -all "color:5;"  $string "color:maroon;"  string
    regsub -all "color:6;"  $string "color:purple;"  string
    regsub -all "color:7;"  $string "color:olive;"   string
    regsub -all "color:8;"  $string "color:yellow;"  string
    regsub -all "color:9;"  $string "color:lime;"    string
    regsub -all "color:10;" $string "color:teal;"    string
    regsub -all "color:11;" $string "color:aqua;"    string
    regsub -all "color:12;" $string "color:blue;"    string
    regsub -all "color:13;" $string "color:fuchsia;" string
    regsub -all "color:14;" $string "color:gray;"    string
    regsub -all "color:15;" $string "color:silver;"  string

    # bold
    regsub -all "(\[^\]*)\[\]?" $string "<B>\\1</B>" string
    regsub -all "(\[^\]*)\r" $string "<B>\\1</B>\r" string
    # underline
    regsub -all "(\[^\]*)\[\]?" $string "<U>\\1</U>" string
    regsub -all "(\[^\]*)\r" $string "<U>\\1</U>\r" string
    # reverse
    regsub -all "(\[^\]*)\[\]?" $string "<I>\\1</I>" string
    regsub -all "(\[^\]*)\r" $string "<I>\\1</I>\r" string
    # chr(18)
    regsub -all "(\[^\]*)\[\]?" $string "<S>\\1</S>" string
    regsub -all "(\[^\]*)\r" $string "<S>\\1</S>\r" string

    regsub -all "" $string "</SPAN>" string
    # CTRL+O
    regsub -all "" $string "</SPAN>" string

    return $string
}

proc mc:htmlheader {fid} {
    global mcs mc html top race

    puts $fid "<HTML>"
    puts $fid ""
    puts $fid "<HEAD>"
    puts $fid "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=windows-1251\">"
    puts $fid "<META HTTP-EQUIV=\"Content-Language\" CONTENT=\"ru-RU\">"
    puts $fid "<TITLE>   IRC-Arena   #arena</TITLE>"
    puts $fid "<STYLE type=text/css>"
    puts $fid "BODY {"
    puts $fid "    font-family       : Verdana, Tahoma, Lucida Console, Courier New, Monospace;"
    puts $fid "    font-size         : 13px;"
    puts $fid "    color             : #000000;"
    puts $fid "    background-repeat : no-repeat;"
    puts $fid "    background-color  : #FFFFFF;"
    puts $fid "}"
    puts $fid "TR.el1 {"
    puts $fid "    background-color  : #F0F0F0;"
    puts $fid "}"
    puts $fid "TR.el2 {"
    puts $fid "    background-color  : #E0E0E0;"
    puts $fid "}"
    puts $fid "TH {"
    puts $fid "    font-family       : Verdana, Tahoma, Lucida Console, Courier New, Monospace;"
    puts $fid "    font-size         : 11px;"
    puts $fid "    vertical-align    : middle;"
    puts $fid "    background-color  : #AACCCC;"
    puts $fid "}"
    puts $fid "TH.two {"
    puts $fid "    font-family       : Verdana, Tahoma, Lucida Console, Courier New, Monospace;"
    puts $fid "    font-size         : 11px;"
    puts $fid "    vertical-align    : middle;"
    puts $fid "    background-color  : #D0D0F0;"
    puts $fid "}"
    puts $fid "TD {"
    puts $fid "    font-family       : Verdana, Tahoma, Lucida Console, Courier New, Monospace;"
    puts $fid "    font-size         : 11px;"
    puts $fid "    vertical-align    : top;"
    puts $fid "    white-space       : nowrap;"
    puts $fid "}"
    puts $fid "TD.recs {"
    puts $fid "    font-family       : Verdana, Tahoma, Lucida Console, Courier New, Monospace;"
    puts $fid "    font-size         : 11px;"
    puts $fid "    font-weight       : bold;"
    puts $fid "    text-align        : left;"
    puts $fid "    vertical-align    : middle;"
    puts $fid "    background-color  : #AACCCC;"
    puts $fid "}"
    puts $fid "TD.remorts {"
    puts $fid "    font-size         : 9px;"
    puts $fid "}"
    puts $fid ".num1 {"
    puts $fid "    background-color  : #AACCCC;"
    puts $fid "}"
    puts $fid ".num2 {"
    puts $fid "    background-color  : #D0D0F0;"
    puts $fid "}"
    puts $fid ".title {"
    puts $fid "    font-family       : Verdana, Tahoma, Lucida Console, Courier New, Monospace;"
    puts $fid "    font-size         : 16px;"
    puts $fid "}"
    puts $fid ".none2 {"
    puts $fid "    background-color  : #DFDFF0;"
    puts $fid "}"
    puts $fid "TABLE {"
    puts $fid "    border            : #AAAAAA 1px solid;"
    puts $fid "}"
    puts $fid "A:link, A:visited {"
    puts $fid "    color             : #0000FF;"
    puts $fid "    text-decoration   : none;"
    puts $fid "}"
    puts $fid "A:hover, A:active {"
    puts $fid "    color             : #0000FF;"
    puts $fid "    text-decoration   : underline;"
    puts $fid "}"
    puts $fid "A.team:link, A.team:visited {"
    puts $fid "    color             : #008000;"
    puts $fid "    text-decoration   : none;"
    puts $fid "}"
    puts $fid "A.team:hover, A.team:active {"
    puts $fid "    color             : #FF0000;"
    puts $fid "    text-decoration   : none;"
    puts $fid "}"
    puts $fid "</STYLE>"
    puts $fid "</HEAD>"
    puts $fid ""
    puts $fid "<BODY>"
    puts $fid ""
}

proc mc:htmlfooter {fid} {
    global mcs mc html top race

    puts $fid ""
    puts $fid "</BODY>"
    puts $fid ""
    puts $fid "</HTML>"
}

proc mc:htmlseparator {fid} {
    global mc html

    puts $fid "<HR WIDTH=\"$html(tablewidth)\">"
}

proc mc:htmlnewline {fid} {
    puts $fid "<BR>"
}

proc mc:htmltitle {fid text} {
    puts $fid "<CENTER><DIV CLASS=\"title\"><B>[mc:htmlchars $text]</B></DIV></CENTER>"
}

proc mc:htmldate {fid align} {
    global mc html

    switch -- $align {
        "left"  { set align "LEFT"   }
        "right" { set align "RIGHT"  }
        default { set align "CENTER" }
    }
    puts $fid "<DIV ALIGN=\"$align\">  [clock format [expr [clock seconds] + $mc(timeshift)] -format "%d.%m.%Y"]  [clock format [expr [clock seconds] + $mc(timeshift)] -format "%H:%M:%S"].</DIV>"
}

proc mc:htmlversion {fid} {
    global mc html admin

    puts $fid "<CENTER> : [mc:htmlchars [format $mc(cop) $mc(ver)]].<BR> : [mc:htmlchars $admin].</CENTER>"
}

proc mc:htmlaname {fid name} {
    global mc html

    puts $fid "<A NAME=\"$name\"></A>"
}

proc mc:htmlahref {fid href name} {
    global mc html

    puts $fid "<A HREF=\"$href\">$name</A>"
}

proc mc:htmlcentero {fid} {
    global mc html

    puts $fid "<CENTER>"
}

proc mc:htmlcenterc {fid} {
    global mc html

    puts $fid "</CENTER>"
}

proc mc:htmltopexp {fid size} {
    global mc mcs mco html basehref top prof race explinks

    if {![info exists top(exp)]} { return }

    mc:log "Generate html-exp..."

    set length [llength $top(exp)]
    if {$length == 0} { return }

    if {$size > 0} { set length $size }
    if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

    foreach cid [array names mco] {
        foreach e [mc:mcomget $cid 1] {
            if {[lindex $e 1] > 0} {
                set com($cid) [lappend com($cid) [lindex $e 0]]
            }
        }
    }

    puts $fid "<CENTER><B> : [llength [array names mcs]]</B></CENTER>"

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"$html(tablewidth)\">"
    ### #
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### /
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
#    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"

    puts $fid "  <THEAD>"
#    puts $fid "  <TR><TH>#</TH><TH></TH><TH>/</TH><TH></TH><TH COLSPAN=\"2\"></TH><TH>Eff</TH><TH COLSPAN=\"2\"></TH><TH></TH><TH></TH><TH></TH><TH></TH><TH><BR></TH></TR>"
    puts $fid "  <TR><TH>#</TH><TH></TH><TH>/</TH><TH></TH><TH COLSPAN=\"2\"></TH><TH COLSPAN=\"2\"></TH><TH></TH><TH></TH><TH></TH><TH></TH><TH><BR></TH></TR>"
    puts $fid "  </THEAD>"

    set temp 1
    puts $fid "  <TBODY>"
    for { set num 1 } { $num <= $length } { incr num } {
        if { $temp == 1 } {
            set temp 2
        } else {
            set temp 1
        }
        if { $num > [llength $top(exp)] } {
            puts $fid "  <TR CLASS=el$temp><TD>$num</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>"
        } else {
            if { [array exists char] } { unset char }
            set id [lindex $top(exp) [expr $num - 1]]

            set explinks($id) 1

            set char(num)   "$num"

            set char(nick)  "[ms:dfl [mc:getstat nick $id]]"
            set char(nick2) "[ms:dfl [mc:getstat nick $id]]"
            if {[mc:getstat nodrop $id] == 1} {
                set char(nick2) "<U>$char(nick2)</U>"
            }

            set char(cr) "[lindex $prof([mc:getstat prof $id]) 0]/[lindex [lindex $race([mc:getstat race $id]) 0] [mc:getstat sex $id]]"
            if {[mc:getstat trace $id] != ""} {
                set char(cr) [mc:delstrips [mc:getstat trace $id]]
            }

            set char(exp) [mc:getstat exp $id]

            set char(level) [mc:getstat level $id]

            set char(remort) [mc:getstat remort $id]

            set char(com) [mc:getstat com $id]

            set char(comreg) "&nbsp;&nbsp;"
            if {[info exist mco([mc:comid $char(com)])]} {
                if {[lsearch -exact $com([mc:comid $char(com)]) $id] != -1} {
                    set char(com) [mc:mcomget [mc:comid $char(com)] 0]
                    set char(com) [mc:htmlcomname $char(com)]
                    set char(comreg) "<A CLASS=team HREF=\"$basehref(exp_team)#topteam_[mc:comid [mc:getstat com $id]]\"></A>"
                } else {
                    set char(com) "-"
                }
            } else {
                set char(com) [mc:htmlcomname $char(com)]
            }

            set char(game)  [mc:getstat game $id]
            set char(win)   [mc:getstat win $id]
            set char(death) [mc:getstat death $id]
            set char(run)   [mc:getstat run $id]
            if {[mc:getstat game $id] != 0} {
                set char(percw) "[format "%.2f" [expr $char(win)   * 100.0 / $char(game)]]%"
                set char(percd) "[format "%.2f" [expr $char(death) * 100.0 / $char(game)]]%"
                set char(percr) "[format "%.2f" [expr $char(run)   * 100.0 / $char(game)]]%"
            } else {
                set char(percw) "0.00%"
                set char(percd) "0.00%"
                set char(percr) "0.00%"
            }
            set char(ltime) "[clock format [expr [mc:getstat ltime $id] + $mc(timeshift)] -format "%d.%m.%Y"]"

#            set char(eff) 10
#            set l $char(remort)
#            for {} {$l > 0} {incr l -1} {
#                set char(eff) [expr $char(eff) * 10]
#            }
#            set char(eff) [expr2 2 (1.0 * $char(level) * ($char(remort) + 1) / $char(game)) * $char(eff) * 100 ]
#            if {$char(game) < 50} { set char(eff) "-" }

#            puts $fid "  <TR CLASS=el$temp><TD>$char(num)</TD><TD><A NAME=\"topexp_$char(nick)\">$char(nick2)</A></TD><TD>$char(cr)</TD><TD>$char(exp)</TD><TD>$char(level)</TD><TD>$char(remort)</TD><TD>$char(eff)</TD><TD>$char(com)</TD><TD>$char(comreg)</TD><TD>$char(game)</TD><TD>$char(win)</TD><TD>$char(death)</TD><TD>$char(run)</TD><TD>$char(ltime)</TD></TR>"
            puts $fid "  <TR CLASS=el$temp><TD>$char(num)</TD><TD><A NAME=\"topexp_$char(nick)\">$char(nick2)</A></TD><TD>$char(cr)</TD><TD>$char(exp)</TD><TD>$char(level)</TD><TD>$char(remort)</TD><TD>$char(com)</TD><TD>$char(comreg)</TD><TD>$char(game)</TD><TD>$char(win)</TD><TD>$char(death)</TD><TD>$char(run)</TD><TD>$char(ltime)</TD></TR>"
        }
    }
    puts $fid "  </TBODY>"

    puts $fid "  <TFOOT>"
#    puts $fid "  <TR><TH>#</TH><TH></TH><TH>/</TH><TH></TH><TH COLSPAN=\"2\"></TH><TH>Eff</TH><TH COLSPAN=\"2\"></TH><TH></TH><TH></TH><TH></TH><TH></TH><TH><BR></TH></TR>"
    puts $fid "  <TR><TH>#</TH><TH></TH><TH>/</TH><TH></TH><TH COLSPAN=\"2\"></TH><TH COLSPAN=\"2\"></TH><TH></TH><TH></TH><TH></TH><TH></TH><TH><BR></TH></TR>"
    puts $fid "  </TFOOT>"
    puts $fid "</TABLE>"
    puts $fid ""
}

proc mc:htmltopteam {fid size} {
    global mc mcs mco html basehref top explinks

    if {![info exists top(team)]} { return }

    mc:log "Generate html-team..."

    set length [llength $top(team)]
    if {$length == 0} { return }

    if {$size > 0} { set length $size }
    if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"$html(tablewidth)\">"
    ### #
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"

    puts $fid "  <THEAD>"
    puts $fid "  <TR><TH>#</TH><TH></TH><TH></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH></TR>"
    puts $fid "  </THEAD>"

    set temp 1
    puts $fid "  <TBODY>"
    for {set num 1} {$num <= $length} {incr num} {
        if {$temp == 1} {
            set temp 2
        } else {
            set temp 1
        }
        if {$num > [llength $top(team)]} {
            puts $fid "  <TR CLASS=el$temp><TD>$num</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>"
        } else {
            if {[array exists com]} { unset com }
            set cid [lindex $top(team) [expr $num - 1]]
            set com(num)   $num
            set com(name)  [mc:htmlcomname [mc:mcomget $cid 0]]

            set com(owner) "&nbsp;"
            set com(size) 0
            set com(exp) 0
            set com(levels) 0
            set com(remorts) 0
            foreach id [mc:mcomget $cid 1] {
                if { [info exists mcs([lindex $id 0])] } {
                    if { [lindex $id 1] == 100 } {
                        set com(owner) [ms:dfl [mc:getstat nick [lindex $id 0]]]
                        if { [info exists explinks([lindex $id 0])] } {
                            set com(owner) "<A HREF=\"$basehref(team_exp)#topexp_$com(owner)\">$com(owner)</A>"
                        }
                    }
                    if { [lindex $id 1] > 0 } {
                        set id [lindex $id 0]
                        incr com(size)
                        incr com(exp)     [mc:getstat exp $id]
                        incr com(levels)  [mc:getstat level $id]
                        incr com(remorts) [mc:getstat remort $id]
                    }
                }
            }

            set com(games) [mc:mcomget $cid 2]
            set com(wins)  [mc:mcomget $cid 3]
            if {$com(games) > 0} {
                set com(percw) [format "%.2f%%" [expr $com(wins) * 100.0 / $com(games)] ]
            } else {
                set com(percw) "0.00%"
            }
            set com(ltime) "[clock format [expr [mc:mcomget $cid 5] + $mc(timeshift)] -format "%d.%m.%Y"]"

            puts $fid "  <TR CLASS=el$temp><TD>$com(num)</TD><TD><A NAME=\"topteam_$cid\">$com(name)</A></TD><TD>$com(owner)</TD><TD>$com(size)</TD><TD>$com(exp)</TD><TD>$com(levels)</TD><TD>$com(remorts)</TD><TD>$com(games)</TD><TD>$com(wins)</TD><TD>$com(percw)</TD><TD>$com(ltime)</TD></TR>"
        }
    }
    puts $fid "  </TBODY>"

    puts $fid "  <TFOOT>"
    puts $fid "  <TR><TH>#</TH><TH></TH><TH></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH><TH><BR></TH></TR>"
    puts $fid "  </TFOOT>"
    puts $fid "</TABLE>"
    puts $fid ""
}

proc mc:htmltopprof {fid size} {
    global mcs mc html basehref top prof explinks

    mc:log "Generate html-prof..."

    set order [split [mc:allprof] ""]
    set length 0
    foreach p $order {
        if {[info exists top(prof$p)] && [llength $top(prof$p)] > $length} {
            set length [llength $top(prof$p)]
        }
    }
    if {$length == 0} { return }

    if {$size > 0} { set length $size }
    if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"$html(tablewidth)\">"
    for {set i 0} {$i < [llength $order]} {incr i} {
        puts $fid "  <!-- separator -->"
        puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
        puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
        puts $fid "  <COLGROUP ALIGN=\"LEFT\">"
        puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    }
    puts $fid "  <THEAD>"

    set str "  <TR>"
    for {set i 0} {$i < [llength $order]} {incr i} {
        set pf [lindex $prof([lindex $order $i]) 0]
        switch -- [lindex $order $i] {
            l { set pf "${pf}" }
            m { set pf "${pf}" }
            p { set pf "${pf}" }
            w { set pf "${pf}" }
        }
        set str "$str<TH COLSPAN=4 WIDTH=\"[format "%.2f" [expr 100.0 / [llength $order]]]%\">$pf ( [llength $top(prof[lindex $order $i])])</TH>"
    }
    puts $fid "$str</TR>"

    set str "  <TR>"
    for {set i 0} {$i < [llength $order]} {incr i} {
        set str "$str<TH CLASS=two WIDTH=\"3.5%\">#</TH><TH CLASS=two></TH><TH CLASS=two ALIGN=CENTER></TH><TH CLASS=two>R</TH>"
    }
    puts $fid "$str</TR>"

    set temp 1
    puts $fid "  </THEAD>"
    puts $fid "  <TBODY>"
    for {set i 0} {$i < $length} {incr i} {
        set str "  <TR CLASS=el$temp>"
        if {$temp == 1} {
            set temp 2
        } else {
            set temp 1
        }
        for {set j 0} {$j < [llength $order]} {incr j} {
            set str "$str<TD CLASS=num2>[expr $i + 1]</TD>"

            if {$i >= [llength $top(prof[lindex $order $j])]} {
               #puts $fid "    <TD COLSPAN=3>&nbsp;</TD>"
                set str "$str<TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>"
            } else {
                set id [lindex $top(prof[lindex $order $j]) $i]
                set nicklink "[ms:dfl [mc:getstat nick $id]]"
                if { [info exists explinks($id)] } {
                    set nicklink "<A HREF=\"$basehref(prof_exp)#topexp_[ms:dfl [mc:getstat nick $id]]\">$nicklink</A>"
                }
                set level [mc:getstat level $id]
                if {$level < 10} { set level "0$level" }
                set str "$str<TD>$nicklink</TD><TD>$level<B>/</B>[mc:getstat exp $id]</TD><TD>[mc:getstat remort $id]</TD>"
            }
        }
        puts $fid "$str</TR>"
    }
    puts $fid "  </TBODY>"
    puts $fid "  <TFOOT>"

    set str "  <TR>"
    for {set i 0} {$i < [llength $order]} {incr i} {
        set str "$str<TH CLASS=two>#</TH><TH CLASS=two></TH><TH CLASS=two ALIGN=CENTER></TH><TH CLASS=two>R</TH>"
    }
    puts $fid "$str</TR>"

    set str "  <TR>"
    for {set i 0} {$i < [llength $order]} {incr i} {
        set pf [lindex $prof([lindex $order $i]) 0]
        switch -- [lindex $order $i] {
            l { set pf "${pf}" }
            m { set pf "${pf}" }
            p { set pf "${pf}" }
            w { set pf "${pf}" }
        }
        set str "$str<TH COLSPAN=4>$pf ( [llength $top(prof[lindex $order $i])])</TH>"
    }
    puts $fid "$str</TR>"

    puts $fid "  </TFOOT>"
    puts $fid "</TABLE>"
    puts $fid ""
}

proc mc:htmltoprace {fid size} {
    global mcs mc html basehref top race explinks

    mc:log "Generate html-race..."

    set order [split [mc:allrace] ""]
    set length 0
    foreach r $order {
        if {[info exists top(race$r)] && [llength $top(race$r)] > $length} {
            set length [llength $top(race$r)]
        }
    }
    if {$length == 0} { return }
    if {$size > 0} { set length $size }
    if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

    ###         
    set neworder ""
    foreach g $order {
        set sz -1
        set rc ""

        foreach r $order {
            if {[lsearch -exact $neworder $r] != -1 || [llength $top(race$r)] <= 0} { continue }

            if {$sz < [llength $top(race$r)]} {
                set sz [llength $top(race$r)]
                set rc $r
            }
        }
        set neworder [lappend neworder $rc]
    }
    set order $neworder

    ###  
    set neworder ""
    for {set i [expr [llength $order] - 1]} {$i >= 0} {incr i -1} {
        set neworder [lappend neworder [lindex $order $i]]
    }
    set order $neworder

    ###  ,    
    set raceinrow 4

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"$html(tablewidth)\">"
    for {set i 0} {$i < $raceinrow} {incr i} {
        puts $fid "  <!-- separator -->"
        puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
        puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
        puts $fid "  <COLGROUP ALIGN=\"LEFT\">"
        puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    }

    foreach {r1 r2 r3 r4} $order {
        set order "$r1 $r2 $r3 $r4"

        ###    ,       
        set neworder ""
        for {set i [expr [llength $order] - 1]} {$i >= 0} {incr i -1} {
            set neworder [lappend neworder [lindex $order $i]]
        }
        set order $neworder

        set length 0
        foreach r $order {
            if {[info exists top(race$r)] && [llength $top(race$r)] > $length} {
                set length [llength $top(race$r)]
            }
        }
        if {$size > 0} { set length $size }
        if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

        puts $fid "  <THEAD>"

        set str "  <TR>"
        for { set i 0 } { $i < $raceinrow } { incr i } {
            if {$i < [llength $order]} {
                set rc [lindex [lindex $race([lindex $order $i]) 0] 3]
                set str "$str<TH COLSPAN=4 WIDTH=\"[format "%.2f" [expr 100.0 / $raceinrow]]%\">$rc ( [llength $top(race[lindex $order $i])])</TH>"
            } else {
                set str "$str<TH COLSPAN=4 WIDTH=\"[format "%.2f" [expr 100.0 / $raceinrow]]%\">&nbsp;</TH>"
            }
        }
        puts $fid "$str</TR>"

        set str "  <TR>"
        for {set i 0} {$i < $raceinrow} {incr i} {
            if {$i < [llength $order]} {
                set str "$str<TH CLASS=two WIDTH=\"3.5%\">#</TH><TH CLASS=two></TH><TH CLASS=two ALIGN=CENTER></TH><TH CLASS=two>R</TH>"
            } else {
                set str "$str<TH CLASS=two WIDTH=\"3.5%\">&nbsp;</TH><TH CLASS=two>&nbsp;</TH><TH CLASS=two ALIGN=CENTER>&nbsp;</TH><TH CLASS=two>&nbsp;</TH>"
            }
        }
        puts $fid "$str</TR>"

        set temp 1
        puts $fid "  </THEAD>"

        puts $fid "  <TBODY>"

        for {set i 0} {$i < $length} {incr i} {
            set str "  <TR CLASS=el$temp>"
            if {$temp == 1} {
                set temp 2
            } else {
                set temp 1
            }
            for {set j 0} {$j < $raceinrow} {incr j} {
                set str "$str<TD CLASS=num2>[expr $i + 1]</TD>"

                if {$j >= [llength $order] || $i >= [llength $top(race[lindex $order $j])]} {
                    set str "$str<TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>"
                } else {
                    set id [lindex $top(race[lindex $order $j]) $i]
                    set nicklink "[ms:dfl [mc:getstat nick $id]]"
                    if { [info exists explinks($id)] } {
                        set nicklink "<A HREF=\"$basehref(race_exp)#topexp_[ms:dfl [mc:getstat nick $id]]\">$nicklink</A>"
                    }
                    set level [mc:getstat level $id]
                    if {$level < 10} { set level "0$level" }
                    set str "$str<TD>$nicklink</TD><TD>$level<B>/</B>[mc:getstat exp $id]</TD><TD>[mc:getstat remort $id]</TD>"
                }
            }
            puts $fid "$str</TR>"
        }

        puts $fid "  </TBODY>"
    }

    puts $fid "</TABLE>"
    puts $fid ""
}

proc mc:htmltopgame {fid size} {
    global mcs mc html basehref top race explinks

    if { ![info exists top(game)] } { return }

    mc:log "Generate html-game..."

    set length [llength $top(game)]
    if {$length == 0} { return }

    if {$size > 0} { set length $size }
    if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"85%\">"
    ### #
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"

    puts $fid "  <THEAD>"
    puts $fid "  <TR><TH CLASS=two>#</TH><TH CLASS=two></TH><TH CLASS=two></TH><TH CLASS=two></TH><TH CLASS=two><BR></TH><TH CLASS=two></TH><TH CLASS=two><BR></TH><TH CLASS=two></TH><TH CLASS=two><BR></TH><TH CLASS=two><BR></TH>"
    puts $fid "  </THEAD>"

    set temp 1
    puts $fid "  <TBODY>"
    for {set num 1} {$num <= $length} {incr num} {
        if {$temp == 1} {
            set temp 2
        } else {
            set temp 1
        }
        if {$num > [llength $top(game)]} {
            puts $fid "  <TR CLASS=el$temp><TD>$num</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>"
        } else {
            if {[array exists char]} { unset char }
            set id [lindex $top(game) [expr $num - 1]]
            set char(num)   $num
            set char(nick)  [ms:dfl [mc:getstat nick $id]]
            if { [info exists explinks($id)] } {
                set char(nick) "<A HREF=\"$basehref(game_exp)#topexp_$char(nick)\">$char(nick)</A>"
            }
            set char(game)  [mc:getstat game $id]
            set char(win)   [mc:getstat win $id]
            set char(death) [mc:getstat death $id]
            set char(run)   [mc:getstat run $id]

            if {$char(game) != 0} {
                set char(percw) "[format "%.2f" [expr $char(win)   * 100.0 / $char(game)]]%"
                set char(percd) "[format "%.2f" [expr $char(death) * 100.0 / $char(game)]]%"
                set char(percr) "[format "%.2f" [expr $char(run)   * 100.0 / $char(game)]]%"
            } else {
                set char(percw) "0.00%"
                set char(percd) "0.00%"
                set char(percr) "0.00%"
            }
            set char(ltime) [clock format [expr [mc:getstat ltime $id] + $mc(timeshift)] -format "%d.%m.%Y %H:%M:%S"]

            puts $fid "  <TR CLASS=el$temp><TD>$char(num)</TD><TD>$char(nick)</TD><TD>$char(game)</TD><TD>$char(win)</TD><TD>$char(percw)</TD><TD>$char(death)</TD><TD>$char(percd)</TD><TD>$char(run)</TD><TD>$char(percr)</TD><TD>$char(ltime)</TD></TR>"
        }
    }

    puts $fid "  </TBODY>"
    puts $fid "</TABLE>"
    puts $fid ""
}

proc mc:htmltopwin {fid size} {
    global mcs mc html basehref top race explinks

    if {![info exists top(win)]} { return }

    mc:log "Generate html-win..."

    set length [llength $top(win)]
    if {$length == 0} { return }

    if {$size > 0} { set length $size }
    if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"50%\">"
    ### #
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"

    puts $fid "  <THEAD>"
    puts $fid "  <TR><TH CLASS=two>#</TH><TH CLASS=two></TH><TH CLASS=two><BR></TH><TH CLASS=two><BR></TH><TH CLASS=two><BR></TH>"
    puts $fid "  </THEAD>"

    set temp 1
    puts $fid "  <TBODY>"
    for {set num 1} {$num <= $length} {incr num} {
        if {$temp == 1} {
            set temp 2
        } else {
            set temp 1
        }
        if {$num > [llength $top(win)]} {
            puts $fid "  <TR CLASS=el$temp><TD>$num</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>"
        } else {
            if {[array exists char]} { unset char }
            set id [lindex $top(win) [expr $num - 1]]
            set char(num)   "$num"
            set char(nick)  "[ms:dfl [mc:getstat nick $id]]"
            if { [info exists explinks($id)] } {
                set char(nick) "<A HREF=\"$basehref(win_exp)#topexp_$char(nick)\">$char(nick)</A>"
            }
            set char(win)   "[mc:getstat win $id]"
            set char(game)  "[mc:getstat game $id]"
            if {[mc:getstat game $id] != 0} {
                set char(perc)  "[format "%.2f" [expr [mc:getstat win $id] * 100.0 / [mc:getstat game $id]]]%"
            } else {
                set char(perc)  "0.00%"
            }
            puts $fid "  <TR CLASS=el$temp><TD>$char(num)</TD><TD>$char(nick)</TD><TD>$char(win)</TD><TD>$char(game)</TD><TD>$char(perc)</TD></TR>"
        }
    }

    puts $fid "  </TBODY>"
    puts $fid "</TABLE>"
    puts $fid ""
}

proc mc:htmltopdeath {fid size} {
    global mcs mc html basehref top race explinks

    if {![info exists top(death)]} { return }

    mc:log "Generate html-death..."

    set length [llength $top(death)]
    if {$length == 0} { return }

    if {$size > 0} { set length $size }
    if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"50%\">"
    ### #
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"

    puts $fid "  <THEAD>"
    puts $fid "  <TR><TH CLASS=two>#</TH><TH CLASS=two></TH><TH CLASS=two><BR></TH><TH CLASS=two><BR></TH><TH CLASS=two><BR></TH>"
    puts $fid "  </THEAD>"

    set temp 1
    puts $fid "  <TBODY>"
    for {set num 1} {$num <= $length} {incr num} {
        if {$temp == 1} {
            set temp 2
        } else {
            set temp 1
        }
        if {$num > [llength $top(death)]} {
            puts $fid "  <TR CLASS=el$temp><TD>$num</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>"
        } else {
            if {[array exists char]} { unset char }
            set id [lindex $top(death) [expr $num - 1]]
            set char(num)   "$num"
            set char(nick)  "[ms:dfl [mc:getstat nick $id]]"
            if { [info exists explinks($id)] } {
                set char(nick) "<A HREF=\"$basehref(death_exp)#topexp_$char(nick)\">$char(nick)</A>"
            }
            set char(death) "[mc:getstat death $id]"
            set char(game)  "[mc:getstat game $id]"
            if {[mc:getstat game $id] != 0} {
                set char(perc)  "[format "%.2f" [expr [mc:getstat death $id] * 100.0 / [mc:getstat game $id]]]%"
            } else {
                set char(perc)  "0.00%"
            }
            puts $fid "  <TR CLASS=el$temp><TD>$char(num)</TD><TD>$char(nick)</TD><TD>$char(death)</TD><TD>$char(game)</TD><TD>$char(perc)</TD></TR>"
        }
    }

    puts $fid "  </TBODY>"
    puts $fid "</TABLE>"
    puts $fid ""
}

proc mc:htmltoprun {fid size} {
    global mcs mc html basehref top race explinks

    if {![info exists top(run)]} { return }

    mc:log "Generate html-run..."

    set length [llength $top(run)]
    if {$length == 0} { return }

    if {$size > 0} { set length $size }
    if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"50%\">"
    ### #
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"

    puts $fid "  <THEAD>"
    puts $fid "  <TR><TH CLASS=two>#</TH><TH CLASS=two></TH><TH CLASS=two><BR></TH><TH CLASS=two><BR></TH><TH CLASS=two><BR></TH>"
    puts $fid "  </THEAD>"

    set temp 1
    puts $fid "  <TBODY>"
    for {set num 1} {$num <= $length} {incr num} {
        if {$temp == 1} {
            set temp 2
        } else {
            set temp 1
        }
        if {$num > [llength $top(run)]} {
            puts $fid "  <TR CLASS=el$temp><TD>$num</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>"
        } else {
            if {[array exists char]} { unset char }
            set id [lindex $top(run) [expr $num - 1]]
            set char(num)  $num
            set char(nick) [ms:dfl [mc:getstat nick $id]]
            if { [info exists explinks($id)] } {
                set char(nick) "<A HREF=\"$basehref(run_exp)#topexp_$char(nick)\">$char(nick)</A>"
            }
            set char(run)  [mc:getstat run $id]
            set char(game) [mc:getstat game $id]
            if {[mc:getstat game $id] != 0} {
                set char(perc)  "[format "%.2f" [expr [mc:getstat run $id] * 100.0 / [mc:getstat game $id]]]%"
            } else {
                set char(perc)  "0.00%"
            }
            puts $fid "  <TR CLASS=el$temp><TD>$char(num)</TD><TD>$char(nick)</TD><TD>$char(run)</TD><TD>$char(game)</TD><TD>$char(perc)</TD></TR>"
        }
    }

    puts $fid "  </TBODY>"
    puts $fid "</TABLE>"
    puts $fid ""
}

proc mc:htmltoplived {fid size} {
    global mcs mc html basehref top prof race explinks

    if {![info exists top(lived)]} { return }

    mc:log "Generate html-lived..."

    set length [llength $top(lived)]
    if {$length == 0} { return }

    if {$size > 0} { set length $size }
    if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"80%\">"
    ### #
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### /
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"

    puts $fid "  <THEAD>"
    puts $fid "  <TR><TH CLASS=two>#</TH><TH CLASS=two></TH><TH CLASS=two>/</TH><TH CLASS=two><BR></TH><TH CLASS=two></TH><TH CLASS=two COLSPAN=2></TH><TH CLASS=two></TH><TH CLASS=two></TH><TH CLASS=two></TH><TH CLASS=two></TH>"
    puts $fid "  </THEAD>"

    set temp 1
    puts $fid "  <TBODY>"
    for {set num 1} {$num <= $length} {incr num} {
        if {$temp == 1} {
            set temp 2
        } else {
            set temp 1
        }
        if {$num > [llength $top(lived)]} {
            puts $fid "  <TR CLASS=el$temp><TD>$num</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>"
        } else {
            if {[array exists char]} { unset char }
            set id [lindex $top(lived) [expr $num - 1]]
            set char(num)    $num
            set char(nick)   [ms:dfl [mc:getstat nick $id]]
            if { [info exists explinks($id)] } {
                set char(nick) "<A HREF=\"$basehref(lived_exp)#topexp_$char(nick)\">$char(nick)</A>"
            }
            set char(cr) "[lindex $prof([mc:getstat prof $id]) 0]/[lindex [lindex $race([mc:getstat race $id]) 0] [mc:getstat sex $id]]"
            if {[mc:getstat trace $id] != ""} {
                set char(cr) [mc:delstrips [mc:getstat trace $id]]
            }
            set char(exp)    [mc:getstat exp $id]
            set char(level)  [mc:getstat level $id]
            set char(remort) [mc:getstat remort $id]
            set char(ctime)  [clock format [expr [mc:getstat ctime $id] + $mc(timeshift)] -format "%d.%m.%Y %H:%M:%S"]
            set char(game)   [mc:getstat game $id]
            set char(win)    [mc:getstat win $id]
            set char(death)  [mc:getstat death $id]
            set char(run)    [mc:getstat run $id]
            puts $fid "  <TR CLASS=el$temp><TD>$char(num)</TD><TD>$char(nick)</TD><TD>$char(cr)</TD><TD>$char(ctime)</TD><TD>$char(exp)</TD><TD>$char(level)</TD><TD>$char(remort)</TD><TD>$char(game)</TD><TD>$char(win)</TD><TD>$char(death)</TD><TD>$char(run)</TD></TR>"
        }
    }

    puts $fid "  </TBODY>"
    puts $fid "</TABLE>"
    puts $fid ""
}

proc mc:htmltopnewbie {fid size} {
    global mcs mc html basehref top prof race explinks

    if {![info exists top(newbie)]} { return }

    mc:log "Generate html-newbie..."

    set length [llength $top(newbie)]
    if {$length == 0} { return }

    if {$size > 0} { set length $size }
    if {$size < 0 && $length > [expr abs($size)]} { set length [expr abs($size)] }

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"80%\">"
    ### #
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### /
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ###  
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"

    puts $fid "  <THEAD>"
    puts $fid "  <TR><TH CLASS=two>#</TH><TH CLASS=two></TH><TH CLASS=two>/</TH><TH CLASS=two><BR></TH><TH CLASS=two></TH><TH CLASS=two></TH><TH CLASS=two></TH><TH CLASS=two></TH><TH CLASS=two></TH>"
    puts $fid "  </THEAD>"

    set temp 1
    puts $fid "  <TBODY>"
    for {set num 1} {$num <= $length} {incr num} {
        if {$temp == 1} {
            set temp 2
        } else {
            set temp 1
        }
        if {$num > [llength $top(newbie)]} {
            puts $fid "  <TR CLASS=el$temp><TD>$num</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>"
        } else {
            if {[array exists char]} { unset char }
            set id [lindex $top(newbie) [expr $num - 1]]

            set char(num)   $num
            set char(nick)  [ms:dfl [mc:getstat nick $id]]
            if { [info exists explinks($id)] } {
                set char(nick) "<A HREF=\"$basehref(newbie_exp)#topexp_$char(nick)\">$char(nick)</A>"
            }
            set char(cr) "[lindex $prof([mc:getstat prof $id]) 0]/[lindex [lindex $race([mc:getstat race $id]) 0] [mc:getstat sex $id]]"
            if {[mc:getstat trace $id] != ""} {
                set char(cr) [mc:delstrips [mc:getstat trace $id]]
            }
            set char(exp)   [mc:getstat exp $id]
            set char(ctime) [clock format [expr [mc:getstat ctime $id] + $mc(timeshift)] -format "%d.%m.%Y %H:%M:%S"]
            set char(game)  [mc:getstat game $id]
            set char(win)   [mc:getstat win $id]
            set char(death) [mc:getstat death $id]
            set char(run)   [mc:getstat run $id]
            puts $fid "  <TR CLASS=el$temp><TD>$char(num)</TD><TD>$char(nick)</TD><TD>$char(cr)</TD><TD>$char(ctime)</TD><TD>$char(exp)</TD><TD>$char(game)</TD><TD>$char(win)</TD><TD>$char(death)</TD><TD>$char(run)</TD></TR>"
        }
    }

    puts $fid "  </TBODY>"
    puts $fid "</TABLE>"
    puts $fid ""
}

proc mc:htmlremorts {fid} {
    global mcs mc html records

    mc:log "Generate html-remorts..."

    set length 0
    for {set i 1} {$i <= 4} {incr i} {
        if {[info exists records($i)] && [llength $records($i)] > $length} {
            set length [llength $records($i)]
        }
    }
    if {$length == 0} { return }

    puts $fid "<DIV ID=\"remortsate\" BORDER=2 STYLE=\"position: absolute; visibility: hidden\"></DIV>"

    puts $fid "<SCRIPT>"
    puts $fid "function showtip(string) {"
    puts $fid "    if (document.all\[\"remortsate\"\] && string != \"\") {"
    puts $fid "        document.all\[\"remortsate\"\].style.display = 'none';"
    puts $fid "        var sw = document.body.clientWidth;"
    puts $fid "        var sh = document.body.clientHeight;"
    puts $fid "        var dw = document.all\[\"remortsate\"\].clientWidth;"
    puts $fid "        var dh = document.all\[\"remortsate\"\].clientHeight;"
    puts $fid "        var cx = self.event.clientX;"
    puts $fid "        var cy = self.event.clientY;"
    puts $fid "        if (sw < cx + dw + 20) cx = sw - dw - 20;"
    puts $fid "        if (sh < cy + dh + 20) cy = sh - dh - 20;"
    puts $fid "        document.all\[\"remortsate\"\].style.top  = cy + document.body.scrollTop  + 15;"
    puts $fid "        document.all\[\"remortsate\"\].style.left = cx + document.body.scrollLeft + 10;"
    puts $fid "        document.all\[\"remortsate\"\].style.visibility = 'visible';"
    puts $fid "        if (document.all\[\"remortsate\"\]) {"
    puts $fid "            document.all\[\"remortsate\"\].innerHTML = \"<TABLE BGCOLOR=#F0F0F0><TR><TD>\"+ string +\"</TD></TR></TABLE>\";"
    puts $fid "        }"
    puts $fid "        document.all\[\"remortsate\"\].style.display = 'block';"
    puts $fid "    }"
    puts $fid "    return false;"
    puts $fid "}"
    puts $fid "function hidetip() {"
    puts $fid "    if (document.all\[\"remortsate\"\]) {"
    puts $fid "        document.all\[\"remortsate\"\].style.display = 'none';"
    puts $fid "    }"
    puts $fid "    return false;"
    puts $fid "}"
    puts $fid "</SCRIPT>"

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"70%\">"
    ### #
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"

    puts $fid "  <THEAD>"
    puts $fid "    <TR><TH>&nbsp;</TH><TH WIDTH=24%></TH><TH WIDTH=24%></TH><TH WIDTH=24%></TH><TH WIDTH=24%></TH></TR>"
    puts $fid "  </THEAD>"

    puts $fid "  <TBODY>"
    for { set i 1 } { $i <= $length } { incr i } {
        puts $fid "  <TR><TD CLASS=num2>&nbsp;</TD><TD CLASS=num2 COLSPAN=\"100%\"><B> #$i</B></TD></TR>"

        set tnum 1
        for { set k 1 } { $k <= 5 } { incr k } {
            if { $tnum == 1 } {
                set tnum 2
            } else {
                set tnum 1
            }
            set str "    <TR CLASS=el$tnum><TD CLASS=num2>$k</TD>"

            for { set j 1 } { $j <= 4 } { incr j } {
                if { [llength $records($j)] < $i } {
                     set str "$str<TD>&lt;&gt;</TD>"
                } else {
                    set nick [lindex [lindex $records($j) [expr $i - 1]] [expr $k - 1]]
                    if { [lindex $nick 0] == "-" } {
                         set str "$str<TD>&lt;&gt;</TD>"
                    } else {
                        set date  [lindex $nick 1]
                        set game  [lindex $nick 2]
                        set win   [lindex $nick 3]
                        set death [lindex $nick 4]
                        set run   [lindex $nick 5]

                        set temp ""
                        if {$date  != "-" && $date  != ""} { set temp "$temp<TR><TD CLASS=remorts>:</TD><TD CLASS=remorts>$date</TD></TR>"     }
                        if {$game  != "-" && $game  != ""} { set temp "$temp<TR><TD CLASS=remorts>:</TD><TD CLASS=remorts>$game</TD></TR>"      }
                        if {$win   != "-" && $win   != ""} { set temp "$temp<TR><TD CLASS=remorts>:</TD><TD CLASS=remorts>$win</TD></TR>"     }
                        if {$death != "-" && $death != ""} { set temp "$temp<TR><TD CLASS=remorts>:</TD><TD CLASS=remorts>$death</TD></TR>" }
                        if {$run   != "-" && $run   != ""} { set temp "$temp<TR><TD CLASS=remorts>:</TD><TD CLASS=remorts>$run</TD></TR>"  }

                        if { $temp != "" } {
                            set temp "<TABLE>$temp</TABLE>"
                        }

                        set str "$str<TD><A NOHREF onMouseMove=\"showtip('$temp')\" onMouseOut=\"hidetip()\"><B>[ms:dfl [lindex $nick 0]]</B></A></TD>"
                    }
                }
            }
            set str "$str</TR>"
            puts $fid "$str"
        }
    }

    puts $fid "  </TBODY>"
    puts $fid ""
    puts $fid "  <THEAD>"
    puts $fid "    <TR><TH>&nbsp;</TH><TH WIDTH=24%></TH><TH WIDTH=24%></TH><TH WIDTH=24%></TH><TH WIDTH=24%></TH></TR>"
    puts $fid "  </THEAD>"
    puts $fid ""
    puts $fid "</TABLE>"
}

proc mc:htmlrecords {fid} {
    global mcs mc html records

    mc:log "Generate html-records..."

    puts $fid "<TABLE ALIGN=\"CENTER\" BORDER=1 CELLSPACING=0 BORDERCOLORDARK=\"#AAAAAA\" BORDERCOLORLIGTH=\"#AAAAAA\" FRAME=\"BOX\" RULES=\"ALL\" WIDTH=\"50%\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"
    ### 
    puts $fid "  <COLGROUP ALIGN=\"MIDDLE\">"

    ### .  "value nick"
    #set records(5)  "- -"
    ### .   "value nick"
    #set records(6)  "- -"
    ### .   "value nick"
    #set records(7)  "- -"
    ### .     "value nick"
    #set records(8)  "- -"
    ### .   "value nick"
    #set records(9)  "- -"
    ### .   "value nick magic"
    #set records(10) "- - -"
    ### .     "value nick"
    #set records(11) "- -"

    puts $fid "  <TR CLASS=el2><TD CLASS=recs>   </TD><TD>none</TD></TR>"
    puts $fid "  <TR CLASS=el1><TD CLASS=recs>    </TD><TD>none</TD></TR>"
    puts $fid "  <TR CLASS=el2><TD CLASS=recs>   </TD><TD>none</TD></TR>"
    puts $fid "  <TR CLASS=el1><TD CLASS=recs>    </TD><TD>none</TD></TR>"
    puts $fid "  <TR CLASS=el2><TD CLASS=recs>    </TD><TD>none</TD></TR>"
    puts $fid "  <TR CLASS=el1><TD CLASS=recs>   </TD><TD>none</TD></TR>"
    puts $fid "  <TR CLASS=el2><TD CLASS=recs>     </TD><TD>none</TD></TR>"

    puts $fid "  </TBODY>"
    puts $fid "</TABLE>"
    puts $fid ""
}

#source scripts/http.tcl

proc mc:pforum {n uh h c t} {
    global mcs mc html records

    set html [split [http::data "::http::1"] "\n"]

    set fid [open "${arenadir}html.txt" w]
    foreach string $html {
        puts $fid $string
    }
    close $fid

    set topic ""
    set date ""
    set poster ""

    foreach string $html {
        if {[string first "</a></span><span class=\"gensmall\">" $string] != -1} {
            set string [string range $string [expr [string first "class=\"topictitle\" title=\"" $string] + 1] end]
            set string [string range $string [expr [string first ">" $string] + 1] end]
            set string [string range $string 0 [expr [string first "<" $string] - 1]]
            set topic $string
            putlog "TOPIC : $topic"
            continue
        }

        if {[string first "td class=\"row3Right\"" $string] != -1} {
            set string [string range $string [expr [string first ">" $string] + 1] end]
            set string [string range $string [expr [string first ">" $string] + 1] end]
            set date [string range $string 0 [expr [string first "<" $string] - 1]]
            putlog "DATE  : $date"

            set string [string range $string 0 [expr [string first "<a href=\"viewtopic.php?" $string] - 1]]
            set string [string range $string [expr [string first ">" $string] + 1] end]
            if {[string first "</a>" $string] != -1} {
                set string [string range $string 0 [expr [string first "</a>" $string] - 1]]
                set string [string range $string [expr [string first ">" $string] + 1] end]
            }
            set poster $string
            putlog "POSTER: $string"
            continue
        }
    }
}

###     
proc mc:recordremort {string remort id} {
    global mcs mc html records

    putlog "STRING: $string"

    for { set i 1 } { $i <= $remort } { incr i } {
        if { [llength $string] < $i } {
            set string [lappend string "{- - - - - -} {- - - - - -} {- - - - - -} {- - - - - -} {- - - - - -}"]
        }
    }

    set rem [lindex $string [expr $remort - 1]]

    for { set i 0 } { $i < [llength $rem] } { incr i } {
        if { [mc:makeid [lindex [lindex $rem $i] 0]] == $id } {
            break
        } elseif { [lindex [lindex $rem $i] 0] == "-" } {
            set temp [mc:getstat nick $id]
            set temp [lappend temp [clock format [expr [unixtime] + $mc(timeshift)] -format "%d.%m.%Y %H:%M:%S"]]
            set temp [lappend temp [mc:getstat game  $id]]
            set temp [lappend temp [mc:getstat win   $id]]
            set temp [lappend temp [mc:getstat death $id]]
            set temp [lappend temp [mc:getstat run   $id]]
            set rem [lreplace $rem $i $i $temp]
            break
        }
    }

    set string [lreplace $string [expr $remort - 1] [expr $remort - 1] $rem]

    return $string
}
