
proc mc:killghost {} {
    global mc ct mctemp ghost prc todo liv roundstart livnumber nnick
    global interval isize
#    putlog "MC:killghost: Interval == $interval, ISize == $isize"

    utimer $interval {
        mc:killghost
    }

    if { $mc(phase) != 1 } { return }

    incr isize -1

    ###    
    if { $interval <= 15 && $isize == 3 && $mctemp(roundwarning) == 0 } {
        set mctemp(roundwarning) 1

        set list ""
        foreach e [lsort -ascii [array names prc]] {
            if { $prc($e) > 0 } {
                set list [lappend list "[ms:dfl [mc:getstat nick $e]]"]
            }
        }
        if { $list != "" } {
            set suffix ""
            if { [llength $list] == 1 } { set suffix "" }

            set list [join $list "10, 04"]

            mc:say [format $ct(round5) $suffix $list]
        }
    }
    if { $isize >= 0 } { return }

#return

    foreach id [array names liv] {
        if { $prc($id) >= [mc:getstat roundprc $id] } {
            if { [string first "run" $todo($id)] == -1 } {
                set todo($id) [lappend todo($id) "run"]
            }
            set prc($id) 0
            if { ![info exist ghost($id)] } {
                mc:msg [ms:dfl $nnick($id)] $ct(53)
            }
        } elseif { $prc($id) > 0 } {
            set prc($id) 0
            if { [info exist ghost($id)] } {
                if { [string first "run" $todo($id)] == -1 } {
                    set todo($id) [lappend todo($id) "run"]
                }
            }
        }
        if { [info exist ghost($id)] } {
            unset ghost($id)
        }
    }

    mc:checkend
}

proc mc:r_leave {n tt} {
    global mc mcs mcr liv ghost ct killed mcch
    global interval isize

    set id [mc:makeid $n]

    if { [array exists mcch] && [info exists mcch($id)] } { unset mcch($id) }

    if { [array exist killed] && [info exists killed($id)] } { return }
    if { ![info exists mcs($id)] } { return }
    if { [info exist mc(ident)] && [lsearch -exact $mc(ident) $id] != -1 } {
        set nn [lsearch -exact $mc(ident) $id]
        set mc(ident) [lreplace $mc(ident) $nn $nn]
    }
    if { $mc(phase) == 0 } {
        if { [info exist mcs($id)] } {
            mc:punreg $n * * $mc(chan) "!unreg"
        }
    } else {
        if { [info exist liv($id)] } {
            if { $tt == 1 } {
                mc:say [format $ct(0b) [ms:dfl [mc:getstat nick $id]]]
            }
            set ghost($id) [clock seconds]
        }
    }
}

proc mc:r_join {n} {
    global mc mcs ct ghost prc liv ct mcoptions botnick countr noreg
    global interval isize

    if { $n == $botnick } {
      utimer 20 { mcu:checkmoderate }
    }
    if { ![mc:chkflag isident] } { return }

    set id [mc:makeid $n]

    if {![info exists mcs($id)]} { return }
    if {[string index [mc:getstat pass $id] 0] != "-" && ![mc:modeok $id "no-warn"]} {
      if { $mc(phase) == 1 || $mc(phase) == 2 } {
        set tmp [format $ct(0.2) [mc:adjending [expr abs($countr) + 1]] ]
      } elseif { $mc(phase) == 0 && !$noreg } {
        set tmp $ct(0.1)
      } elseif { $mc(phase) == 0 && $noreg } {
        set tmp $ct(0.0)
      } else {
        set tmp $ct(0.3)
      }
      if {[mc:modeok $id "priv-warn"]} {
        putserv "PRIVMSG $n :$ct(0) $tmp"
      } {
        putserv "NOTICE $n :$ct(0) $tmp"
      }
    }
    if { [info exist ghost($id)] } {
        unset ghost($id)
        mc:pushmode $mc(chan) +v $n
        if { $mc(phase) == 1 } {
            if { $prc($id) == 0 } {
                mc:msg $n $ct(0d)
            } else {
                mc:msg $n [format $ct(0c) $prc($id)]
                mc:createlist
                set mcoptions(sendlist) 1
                foreach ls [mc:list [mc:modeok $id "exlist"]] {
                    mc:msg $n $ls
                }
                set mcoptions(sendlist) 0
            }
        }
    }
}

proc mc:spart {n uh h c {m ""}} {
    mc:r_leave $n 1
}

proc mc:ssign {n uh h c r} {
    mc:r_leave $n 1
}

proc mc:skick {n uh h c t r} {
    mc:r_leave $t 0
}

proc mc:snick {n uh h c nn} {
    mc:r_leave $n 1
    mc:r_join $nn
}

proc mc:ssplt {n uh h c} {
    mc:r_leave $n 1
}

proc mc:srejn {n uh h c} {
    mc:r_join $n
}

proc mc:sjoin {n uh h c} {
    mc:r_join $n
}
