
###
###       (  , -  ..)
###

###      
proc error {prc args} {
  putlog "[red]!ERROR![cl] @${prc}: [join $args { }]"
}
###     
proc uerror {txt} {
  upvar n n
  mc:msg $n $txt
  return "return"
}

###  
proc mc:phase {} {
  global mc
  return $mc(phase)
}

###  theme- (type: m - mage, a - main<ct>, h - help<cth>, o - com<cto>)
proc mcmsg {type index {add ""}} {
  global ctm ct cth cto
  append index $add
  switch -- $type {
    m { if {[info exist ctm($index)]} { return $ctm($index) } }
    a { if {[info exist ct($index)]}  { return $ct($index) } }
    h { if {[info exist cth($index)]} { return $cth($index) } }
    o { if {[info exist cto($index)]} { return $cto($index) } }
  }
  putlog "!ERROR! mcmsg $type $index"
  return "#mcmsg#error#"
}
###     
proc mfrm {{add ""}} {
  global type
  if { $add != "" } { set add ".$add" }
  return [mcmsg m $type $add]
}
proc afrm {frm {add ""}} {
  if { $add != "" } { set add ".$add" }
  return [mcmsg a $frm $add]
}
proc hfrm {frm {add ""}} {
  if { $add != "" } { set add ".$add" }
  return [mcmsg h $frm $add]
}
proc ofrm {frm {add ""}} {
  if { $add != "" } { set add ".$add" }
  return [mcmsg o $frm $add]
}


###    
proc mc:sex {args} {
  set ret ""
  foreach id $args {
    lappend ret [mc:getstat sex $id]
  }
  return $ret
}

###   
proc mc:nlog {h c} {
  global mc
  set fid [open $mc(file.nlog) a+]
  puts $fid "[clock format [expr [unixtime] + $mc(timeshift)] -format {%d.%m/%H:%M:%S}] #$h# $c"
  close $fid
}

proc mc:nohighlight {s} {
  return [string map {E  e  T  O  o  P  p  A  a  H  K  X  x  C  c  B  M   E  e  T  O  o  P  p  A  a  H  K  X  x  C  c  B  M} $s]
}
proc mc:ispublicon {} { global mc; return [islinked $mc(bot.public)] }
proc mc:dcclogcmd {h cm t} { putloglev c *0 "#$h# $cm $t" }

proc cleartimers {} {
    foreach e [utimers] {
        if { [string match "*mc:*" $e] } {
            killutimer [lindex $e 2]
        }
    }
}

proc mc:timer {mode name {sec 0} {code 0}} {
  global mctimers

  switch -- $mode {
    "-start" {
      if { $name == "all" } { return 0 }
      mc:timer -stop $name
      set mctimers($name) [utimer $sec $code]
      return 1
    }
    "-stop" {
      if { ![array exist mctimers] } { return 0 }

      if { $name == "all" } {
        foreach name [array names mctimers] {
          mc:timer -stop $name
        }
        return 1
      }

      if { ![info exist mctimers($name)] } { return 0 }

      foreach tid $mctimers($name) {
        foreach tmr [utimers] {
          if { [lindex $tmr 2] == $tid } { killutimer $tid }
        }
      }

      unset mctimers($name)
    }
    "-clear" {
      if { ![array exist mctimers] } { return 0 }
      if { $name == "all" } {
        unset mctimers
        return 1
      }
      if { ![info exist mctimers($name)] } { return 0 }
      unset mctimers($name)
    }
    "-add" {
      if { $name == "all" } { return 0 }
      if { ![array exist mctimers] || ![info exist mctimers($name)] } { set mctimers($name) "" }
      lappend mctimers($name) [utimer $sec $code]
      return 1
    }
  }
}


proc mcu:checkmoderate {} {
    global mc noreg mcr

    if { [string first "m" [getchanmode $mc(chan)]] != -1 && ($noreg == 1 || ![array exists mcr]) } {
        pushmode $mc(chan) -m
    }
    foreach e [utimers] {
        if { [string match "*mcu:checkmoderate*" $e] } {
            killutimer [lindex $e 2]
        }
    }
}

proc mc:msg {h w} {
    global mc mctn mctp mcoptions

    set id [mc:makeid $h]

    if { ![info exists mcoptions(sendlist)] || $mcoptions(sendlist) == 0 } {
        set w [mc:randchars $w]
    }

    if { [array exist mctn] } {
        foreach nn [array names mctn] {
            if { $mctn($nn) == $id && $mctp($nn) != "" } {
                if { [valididx $nn] } {
                    putidx $nn "10$w\r"
                    return
                } else {
                    unset mctn($nn)
                }
            }
        }
    }
    if { [mc:checkflag "F"] } {
        putquick "PRIVMSG $h :10$w"
    } else {
        putserv "PRIVMSG $h :10$w"
    }
}

proc mc:pushmode {c m w} {
  global mc

  pushmode $c $m $w
#  if {[islinked $mc(bot.public)] && [isop $mc(bot.public) $c]} {
#    putbot $mc(bot.public) "ap_pushmode $c $m [mc:tobotnet [split $w]]"
#  } else { }
}

proc mc:say {w} {
    global mc mcoptions roundlines
    if { [info exists roundlines] } { incr roundlines 1 }
    set w "PRIVMSG $mc(chan) :10$w"
    if {[islinked $mc(bot.public)]} {
      putbot $mc(bot.public) "ap_say [mc:tobotnet [split $w]]"
    } {
      puthelp $w
    }
}

proc mc:tsay {h w} {
    global mc mcoptions

    set w "PRIVMSG $mc(chan) :10$h: $w"
    if {[islinked $mc(bot.public)]} {
      putbot $mc(bot.public) "ap_say [mc:tobotnet [split $w]]"
    } elseif { [mc:checkflag "F"] } {
      putquick $w
    } else {
      putserv $w
    }
}

proc mc:notice {h w} {
    global mc

    if { [mc:checkflag "F"] } {
        putquick "NOTICE $h :10$w"
    } else {
        putserv "NOTICE $h :10$w"
    }
}

###  1,      
proc mc:ondcc {id} {
    global mc mctn mctp

    foreach nn [array names mctn] {
        if {$mctn($nn) == $id && $mctp($nn) != ""} {
            return 1
        }
    }

    return 0
}

proc mc:strongspace {s} {
  regsub -all "  " $s " \240" s
  return $s
}

proc mc:delspec {n} {
    regsub -all \\\[ $n "" n
    regsub -all \\\] $n "" n
    regsub -all \\\^ $n "" n
    regsub -all \\\" $n "" n
    regsub -all \\\\ $n "" n
    regsub -all \\\{ $n "" n
    regsub -all \\\} $n "" n
    regsub -all  $n 10 n
    return $n
}

proc mc:delstrips {n} {
    regsub -all "(\[1234567890\]*)(,\[1234567890\]*)?" $n "" n
    regsub -all  $n "" n
    regsub -all  $n "" n
    regsub -all  $n "" n
    regsub -all  $n "" n
    return $n
}

proc mc:delrus {n} {
    regsub -all "\[Ũ\]" $n "" n
    return $n
}

###       $string ,  , 
proc mc:randchars {string} {
    set out ""

#    putlog "mc:RANDCHARS string == $string"

    for { set j 0 } { $j < [string length $string] } { incr j } {
        set rand [rand 2]
        if { $rand == 1 } {
            switch -- [string index $string $j] {
                 { set out "${out}a" }
                 { set out "${out}e" }
                 { set out "${out}o" }
                 { set out "${out}p" }
                 { set out "${out}c" }
                 { set out "${out}x" }
                 { set out "${out}A" }
                 { set out "${out}B" }
                 { set out "${out}E" }
                 { set out "${out}K" }
                 { set out "${out}M" }
                 { set out "${out}H" }
                 { set out "${out}O" }
                 { set out "${out}P" }
                 { set out "${out}C" }
                 { set out "${out}T" }
                 { set out "${out}X" }
                default { set out "$out[string index $string $j]" }
            }
        } else {
            set out "$out[string index $string $j]"
        }
    }

#    putlog "RESULT string: $out"
    return $out
}

proc mc:tolat {string} {
    set out ""
    for {set j 0} {$j < [string length $string]} {incr j} {
        switch -- [string index $string $j] {
             { set out "${out}a" }
             { set out "${out}e" }
             { set out "${out}o" }
             { set out "${out}p" }
             { set out "${out}c" }
             { set out "${out}x" }
             { set out "${out}b" }
             { set out "${out}k" }
             { set out "${out}m" }
             { set out "${out}h" }
             { set out "${out}t" }
            default { set out "$out[string index $string $j]" }
        }
    }
    return $out
}

###  1,       0
proc mc:moderated {} {
    global mc

    if {[string first "m" [getchanmode $mc(chan)]] != -1} {
        return 1
    }
    return 0
}

###   ,    ,   ,    
proc mc:checkvoices {} {
    global mc mcr liv

    if {$mc(phase) < 1} {
        foreach e [array names mcr] {
            if {![isvoice [mc:getstat nick $e] $mc(chan)]} { mc:pushmode $mc(chan) +v [ms:dfl $e] }
        }
    } else {
        foreach e [array names liv] {
            if {![isvoice [mc:getstat nick $e] $mc(chan)]} { mc:pushmode $mc(chan) +v [ms:dfl $e] }
        }
    }
}

###     
proc mc:usersonchan {} {
    global mc

    set users 0
    foreach e [chanlist $mc(chan)] {
        incr users
    }
    return $users
}

proc mc:ismaster {hand} {
    global mc

    if {("[info procs auth:check]" != "") && (![auth:check $hand])} { return 0 }
    if {[regexp "m" "[chattr $hand]"] || [regexp "m" "[chattr $hand $mc(chan)]"]} { return 1 }
    return 0
}

proc mc:findonchan {name} {
    #putlog "MC:findonchan: $name"
    global mc

    if {![validchan $mc(chan)]} { return $name }

    foreach e [chanlist $mc(chan)] {
        if {[tolower $e] == [tolower $name]} {
            #putlog "FINDONCHAN : $e"
            return $e
        }
    }
    return $name
}

###   [expr]     -    (  ).
proc expr2 {size args} {
     if {$size == "-"} {
         return [expr $args]
     } else {
         return [format "%.${size}f" [expr $args]]
     }
}

###   
proc mc:rand {size} {
    return [expr round(rand() * ($size-1)) + 1]
}

proc min {a b} {
    if {$a < $b} {
        return $a
    } else {
        return $b
    }
}

proc max {a b} {
    if {$a > $b} {
        return $a
    } else {
        return $b
    }
}

proc mc:checkflag {fl} {
    global mc

    if {[string first $fl $mc(flags)] != -1} {
        return 1
    } else {
        return 0
    }
}

proc mc:checkin {f w} {
    if {[string length $f] != 1} { return 0 }
    if {[string first $f $w] == -1} { return 0 }

    return 1
}

proc mc:nickexp {} {
    global mc mcs


    set curtime [unixtime]
    putlog " Check NickExp... Current time: [clock format $curtime -format "\[%d.%m.%Y %H:%M:%S\]"]"
    set fid [open $mc(file.nexp) a+]

    foreach e [array names mcs] {
        set g [expr 10 + [mc:getstat remort $e] * 100 + [mc:getstat level $e] * 10]
        if {[mc:getstat nodrop $e] != 1 && (([mc:getstat ltime $e] != 0 && [expr $curtime - [mc:getstat ltime $e]] > [expr 86400 * $g]) || ([mc:getstat ltime $e] == 0 && [expr $curtime - [mc:getstat ctime $e]] > [expr 86400 * $g]))} {
            set clf [clock format [expr [mc:getstat ctime $e] + $mc(timeshift)] -format "\[%d.%m.%Y %H:%M:%S\]"]
            putlog [format "  Nick Expire: \"%-20s\" Last game: %s Reg date: %s" [ms:dfl $e] [clock format [expr [mc:getstat ltime $e] + $mc(timeshift)] -format "\[%d.%m.%Y %H:%M:%S\]"] $clf]
            puts $fid "$e $mcs($e)"
            mc:delnickcom $e
            unset mcs($e)
            if {([info exist mc(ident)]) && ([lsearch -exact $mc(ident) $e] != -1)} {
                set nn [lsearch -exact $mc(ident) $e]
                set mc(ident) [lreplace $mc(ident) $nn $nn]
            }
        }
    }

    close $fid
}

proc mc:teamexp {} {
    global mc mco

    set curtime [unixtime]
    putlog " Check TeamExp... Current time: [clock format $curtime -format "\[%d.%m.%Y %H:%M:%S\]"]"

    foreach cid [array names mco] {
        set g 15
        if {[expr $curtime - [mc:mcomget $cid 5]] > [expr 86400 * $g]} {
            putlog [format "  Nick Expire: \"%-30s\" Last game: %s" [ms:dfl $cid] [clock format [expr [mc:mcomget $cid 5] + $mc(timeshift)] -format "\[%d.%m.%Y %H:%M:%S\]"]]
            unset mco($cid)
        }
    }
}

proc mc:diex {s} {
    if {[string first x $s]==-1} { return $s }
    set min [expr [lindex [split $s x] 0] * 100]
    set max [expr [lindex [split $s x] 1] * 100]

    set result [expr ([rand [expr $max - $min + 1]] + $min) / 100.0]

    return $result
}

proc mc:die {s} {
    set t1 [split $s +]

    if {[llength $t1] == 1} {
        set tmp [split $s d]
        set res 0
    } else {
        set tmp [split [lindex $t1 0] d]
        set res [lindex $t1 1]
    }
    for {set i 1} {$i <= [lindex $tmp 0]} {incr i} {
        set res [expr $res + [rand [lindex $tmp 1]] + 1]
    }

    return $res
}

proc mc:emailrules {n uh h t} {
    global mc
    if {![mc:ismaster $h]} { return }

    exec /bin/mail -s "IRC-Arena $mc(ver) Rules" [lindex $t 1] < $mc(rules)
    mc:msg $n "email send"
}

proc mc:mreset {n uh h t} {
    global mc
    if {![mc:ismaster $h]} { return }
    mc:setbinds [lindex $t 1]
    puthelp "NOTICE $n :   4$mc(chan)"
}

proc mc:fuck {t} {
    regsub -all " " $t ":fuckspace:" t;
    return $t
}

proc mc:unfuck {t} {
    regsub -all ":fuckspace:" $t " " t;
    return $t
}

proc mc:rules {n uh h c t} {
    global mc
    putlog "<<$n>> send rules..."
    dccsend $mc(rules) $n
}

proc mc:pdcc {n uh h c t} {
    global mc

    putquick "PRIVMSG $n :\001DCC CHAT chat [myip] $mc(dccport2)\001"
}

proc mc:t2f {s} {
    binary scan $s c* v
    set vv ""
    foreach vi $v { set vv [lappend vv [expr ($vi + 0x100) % 0x100]] }
    set v $vv
    set a [expr [lindex $v 0] >> 2]
    set a [lappend a [expr (([lindex $v 0] << 4) & 48) + (([lindex $v 1] >> 4) & 15)]]
    set a [lappend a [expr (([lindex $v 1] << 2) & 60) + (([lindex $v 2] >> 6) & 3)]]
    set a [lappend a [expr [lindex $v 2] & 63]]
    set y ""
    foreach bb $a {
        if {$bb == 0} {
            set bb 64
        }
        set bb [expr $bb + 32]
        set y [lappend y $bb]
    }
    set a $y

    return [binary format cccc [lindex $a 0] [lindex $a 1] [lindex $a 2] [lindex $a 3]]
}

proc mc:f2t {s} {
    binary scan $s c* v
    set vv ""
    foreach vi $v { set vv [lappend vv [expr ($vi + 0x100) % 0x100]] }
    set v $vv
    set a1 [expr (([lindex $v 0] - 32) << 2) + ((([lindex $v 1] - 32) & 48) >> 4)]
    set a2 [expr ((([lindex $v 1] - 32) & 15) << 4) + ((([lindex $v 2] - 32) & 60) >> 2)]
    set a3 [expr ((([lindex $v 2] - 32) & 3) << 6) + (([lindex $v 3] - 32) & 63)]

    return [binary format ccc $a1 $a2 $a3]
}

proc mc:encrypt {s} {
    set res ""

    for { set i 1 } { $i <= [expr 1 + [string length $s] / 3] } { incr i } {
        set bb [string range $s [expr ($i - 1) * 3] [expr ($i - 1) * 3 + 2]]

        if { [string length $bb] == 1 } {
            set bb "${bb}\000\000"
        } elseif { [string length $bb] == 2 } {
            set bb "${bb}\000"
        } elseif { [string length $bb] == 0 } {
            return $res
        }

        set res "$res[mc:t2f $bb]"
     }

     return $res
}

proc mc:decrypt {s} {
    set res ""

    for { set i 1 } { $i <= [expr [string length $s] / 4] } { incr i } {
        set bb [string range $s [expr ($i - 1) * 4] [expr ($i - 1) * 4 + 3]]
        set res "$res[mc:f2t $bb]"
    }

    return [string trimright $res \000]
}

proc xformat {s e a} {
    while { [string first &s: $s] != -1 } {
        set i1 [string first &s: $s]
        set i2 [string first : $s [expr $i1 + 3]]
        set i3 [string first : $s [expr $i2 + 1]]
        set i4 [string first : $s [expr $i3 + 1]]
        switch -- $e {
            0 { set asd [string range $s [expr $i1 + 3] [expr $i2 - 1]] }
            1 { set asd [string range $s [expr $i2 + 1] [expr $i3 - 1]] }
            default { set asd [string range $s [expr $i3 + 1] [expr $i4 - 1]] }
        }
        set s [string replace $s $i1 $i4 $asd]
    }
    set asd ""
    foreach nn $a {
        set asd [lappend asd [string map {\\\{ \{ \\\} \} \\\[ \[ \\\] \] \\\$ \$ \\\" \"} $nn]]
    }
    set asd "format \$s $asd"
    return [eval $asd]
}

proc xformat3 {str sex args} {
    for {set j 1} {$j <= [llength $sex]} {incr j} {
        set tmp "&s${j}:"
        while {[string first $tmp $str] != -1} {
            set i1 [string first $tmp $str]
            set i2 [string first : $str [expr $i1 + 4]]
            set i3 [string first : $str [expr $i2 + 1]]
            set i4 [string first : $str [expr $i3 + 1]]
            if { $i1 == -1 || $i2 == -1 || $i3 == -1 || $i4 == -1 } {
                putlog "xformatbug: $str"
                break
            }

            switch -- [lindex $sex [expr $j - 1]] {
                0 { set end [string range $str [expr $i1 + 4] [expr $i2 - 1]] }
                1 { set end [string range $str [expr $i2 + 1] [expr $i3 - 1]] }
                default { set end [string range $str [expr $i3 + 1] [expr $i4 - 1]] }
            }
            set str [string replace $str $i1 $i4 $end]
        }
    }
    set end ""
    foreach nn $args {
        set end [lappend end [string map {\\\{ \{ \\\} \} \\\[ \[ \\\] \] \\\$ \$ \\\" \"} $nn]]
    }
    if { [catch {set end [eval "format \$str $end"]} errstr] } {
      putlog "[red]ERROR in xformat3:[cl]"
      putlog "err: $errstr"
      putlog "frm: $str"
      putlog "arg: $args"
      putlog "[red]End error report.[cl]"
      set end "#error#"
    }
    return $end
}

bind dcc n mc mc_command
bind dcc n ms mc_set

proc mc_command {h i a} {
    global owner

    if {[lsearch -exact [string tolower $owner] [string tolower $h]] == -1 } {
      putidx $i "negative."
    } {
      putlog "MC: [eval mc:$a]"
    }
}

proc mc_set {h i a} {
    global mco mcs mc ct cth ctm mcr mcc mce min ts tl ti tv th twis ta tg te todo liv param nnick prc hitten noreg countr countt
    global mg mr race prof
    global owner

    if {[lsearch -exact [string tolower $owner] [string tolower $h]] == -1 } {
      putidx $i "negative."
      return
    }
    if {[llength [split $a]]==1} {
        set asd $[join [lindex [split $a] 0]]
        eval "set asd $asd"
        putlog "MC: $asd"
    } else {
        putlog "MC: [set [join [lindex [split $a] 0]] [join [lrange [split $a] 1 end]]]"
    }
}

###  $id   ,   = 100,   .
proc mc:delnickcom {id} {
    global mc mcs mco

    foreach cid [array names mco] {
        set access [mc:mcomget $cid 1]
        set deleted 0
        for { set j 0 } { $j < [llength $access] } { incr j } {
            if { [lindex [lindex $access $j] 0] == $id && [lindex [lindex $access $j] 1] == 100 } {
                unset mco($cid)
                set deleted 1
                putlog "DELTEAM $cid"
                break
            } elseif { [lindex [lindex $access $j] 0] == $id } {
                set access [lreplace $access $j $j]
            }
        }
        if { $deleted == 0 } {
            mc:mcomset $cid 1 $access
        }
    }
}

proc mc:createlist {} {
    global mc mcr liv

    set mc(list) ""

    set lastnum 1
    foreach tid [array names mcr] {
        if { $lastnum < $mcr($tid) } { set lastnum $mcr($tid) }
    }

    set nocomlist ""
    for { set i 1 } { $i <= $lastnum } { incr i } {
        foreach id [array names liv] {
            if { $mcr($id) == $i } {
              if { [mc:reg:getstat isnocom $id] } {
                lappend nocomlist $id
              } {
                lappend mc(list) $id
              }
            }
        }
    }

    foreach id $nocomlist { lappend mc(list) $id }
#    putlog "LIST: [ms:dfl $mc(list)]"
}

proc mc:createtopnicks {} {
    global mcs mc prof race topnicks

#    if { $mc(topsize) == 0 } { return }

    mc:log "Calculate experience top..."

    if {[array exist topnicks]} { unset topnicks }
    foreach prf [array names prof] {
      set topnicks($prf) ""
      set list ""
      foreach id [array names mcs] {
        if { [mc:getstat prof $id] != $prf } { continue }
        if { [string index [mc:getstat pass $id] 0] == "-" } { continue }
        set str [mc:getstat level $id]
        if { [string length $str] == 1 } { set str "0$str" } { set str "$str" }
        set rstr [mc:getstat remort $id]
        if { [string length $rstr] == 1 } { set rstr "0$rstr" } { set rstr "$rstr" }
        set estr [mc:getstat exp $id]
        while { [string length $estr] != 10 } {
          set estr "0$estr"
        }
        set str "$rstr$str$estr"
        lappend list "$str $id"
      }
      set list [lsort -ascii -decreasing -index 0 $list]
      foreach rec $list {
          lappend topnicks($prf) [lindex $rec 1]
      }
   }
}

proc mc:dellogs {mi ho da mo ye} {
    global logfile-suffix username
    putlog "MC:dellogs: $mi $ho $da $mo $ye"

    deletelogs "logs/arena.log" ${logfile-suffix} 3 9
    deletelogs "logs/${username}.log"  ${logfile-suffix} 2 9
}

bind time - "01 00 * * *" mc:dellogs

###   $j    $log   $suffix,  $i .
### $log    -  ,  
### $suffix -  
### $i      -  ,   
### $j      -  ,   

proc deletelogs {log suffix i j} {
    set curtime [clock seconds]
    while {[clock format $curtime -format "%S"] != 0} { incr curtime -1 }
    while {[clock format $curtime -format "%M"] != 0} { incr curtime -60 }
    while {[clock format $curtime -format "%H"] != 0} { incr curtime -3600 }

    putlog "Start deleting logs: [clock format $curtime -format "%d%b%Y ! %Y%m%d"]"

    for {} {$i > 0} {incr i -1} {
        set curtime [expr $curtime - 86400]
    }

    for {} {$j > 0} {incr j -1} {
        set filename "$log[clock format $curtime -format $suffix]"
        if {[file exists $filename]} {
            putlog "  Delete: $filename"
            file delete $filename
        }
        set curtime [expr $curtime - 86400]
    }

    putlog "Deleting logs complete"
}

###      4   
proc mc:backupbase {mi ho da mo ye} {
    global mc mcs mco

    if { $mc(backupbase) == 0 || [expr $ho / $mc(backupbase)] != [expr 1.0 * $ho / $mc(backupbase)] } {
        return
    }

    set number [expr ($ho + $mc(backupbase)) / $mc(backupbase)]

    mc:log "Backup base files ($number) [clock format [unixtime] -format "\[%d.%m.%Y %H:%M:%S\]"]"

    ###  
    set fid [open "$mc(file.base).$number.backup" w]
    if { [array exists mcs] } {
        foreach e [array names mcs] { puts $fid "$e $mcs($e)" }
    }
    close $fid

    ###  
    set fid [open "$mc(file.coms).$number.backup" w]
    if { [array exists mco] } {
        foreach e [array names mco] { puts $fid "$e $mco($e)" }
    }
    close $fid
}

bind time - "00 00 * * *" mc:backupbase
bind time - "00 06 * * *" mc:backupbase
bind time - "00 12 * * *" mc:backupbase
bind time - "00 18 * * *" mc:backupbase


proc quicksort {ls count} {
    global quicklist

    set quicklist $ls
    putlog "STR: $quicklist"
    putlog "END: [qs 0 [expr $count - 1]]"
}

proc qs {left right} {
    global quicklist

    set i $left
    set j $right
    set x [lindex $quicklist [expr ($left + $right) / 2]]

    while {$i <= $j} {
        while {[lindex $quicklist $i] < $x && $i < $right} { incr i +1 }
        while {[lindex $quicklist $j] > $x && $j > $left}  { incr j -1 }

        if {$i <= $j} {
            set y [lindex $quicklist $i]
            set quicklist [lreplace $quicklist $i $i [lindex $quicklist $j] ]
            set quicklist [lreplace $quicklist $j $j $y ]
            incr i +1
            incr j -1
        }
    }

    if {$left < $j}  { qs $left $j  }
    if {$right > $j} { qs $i $right }

    return $quicklist
}

proc mc:log {text} {
    putlog "\[06IRC-Arena\] $text"
}

proc mc:logn {nick text} {
    putlog "\[12IRC-Arena:$nick\] $text"
}

###     
proc mc:gainexp {id exp} {
    global mc te

    if { $mc(phase) == 0 } { return 0 }

    set id [mc:makeid $id]
    if { ![info exists te($id)] } { return 0 }

    set maxexp [expr2 0 $mc(gamemaxexp) + $mc(gamemaxexp) * 0.20 * [mc:getstat remort $id]]
    if { [mc:getstat remort $id] > 0 } {
        set maxexp [expr2 0 $maxexp * [min 1.0 [expr 0.1 + [mc:getstat level $id] * 0.1]]]
    }

    if { $te($id) >= $maxexp } {
        set te($id) $maxexp
        return $maxexp
    }

    if { [expr2 0 $te($id) + $exp] > $maxexp } {
        set exp [expr2 0 $maxexp - $te($id) ]
    }

    return [set te($id) [expr2 0 $te($id) + $exp]]
}

###  ,      type
proc mc:isbot {type} {
    global mc botnet-nick

    if { ![info exists mc(bot.$type)] }   { return 0 }
    if { ![info exists botnet-nick] }     { return 0 }
    if { $mc(bot.$type) == ${botnet-nick} } { return 1 }

    return 0
}

###    "߸"  ,    
proc mc:tobotnet {str} {
    regsub -all "" $str "1" str
    regsub -all "" $str "2" str
    regsub -all "" $str "3" str
    regsub -all "" $str "4" str

    return $str
}

proc mc:unbotnet {str} {
    regsub -all "1" $str "" str
    regsub -all "2" $str "" str
    regsub -all "3" $str "" str
    regsub -all "4" $str "" str

    return $str
}

proc mc:istotal {} {
   global mc
   if { [info exist mc(tot.client)] && $mc(tot.enable) } { return 1 } { return 0 }
}

proc mc:loadscript {h idx t} {
    global arenadir
    global lstr
    global owner

    if {[lsearch -exact [string tolower $owner] [string tolower $h]] == -1 } {
      putidx $i "negative."
      return
    }
    set lstr ${arenadir}mc.$t.tcl
    putidx $idx "Try load $lstr...\r"
    if {[catch {uplevel #0 {source $lstr}} errstr]} {
        putidx $idx "Err: $errstr\r"
    } else {
       putidx $idx "$lstr sucssefuly loaded.\r"
    }
}

proc mc:misc:loadresult {} {
  global spells thi thicoll mcweather race prof

  set err "[red]*ERR*[cl]"

  if { ![array exist thi] } { set c_thi $err } {
    set c_thi [expr [array size thi] - 1]
  }
  if { ![array exist spells] } { set c_spells $err } {
    set c_spells [array size spells]
  }
  if { ![array exist thicoll] } { set c_thicoll $err } {
    set c_thicoll [array size thicoll]
  }
  if { ![array exist mcweather] } { set c_weath $err } {
    set c_weath [array size mcweather]
  }
  if { ![array exist prof] } { set c_prof $err } {
    set c_prof [array size prof]
  }
  if { ![array exist race] } { set c_race $err } {
    set c_race [array size race]
  }
  putlog "Total: \[items/$c_thi\] \[collect/$c_thicoll\] \[spells/$c_spells\] \[weather/$c_weath\] \[profs/$c_prof\] \[races/$c_race\]"
}
