
proc mc:telnet:init {} {
  global mc

  listen $mc(dccport1) script mc:tel
  listen $mc(dccport2) script mc:ttel
  bind ctcp - DCC mc:chat
  catch { unbind ctcp - DCC *ctcp:server:DCC }
  putlog "Listen ports $mc(dccport1)/$mc(dccport2) for arena-dcc."
}


proc mc:ip2host {ip} {
  if {![isnumber $ip]} { return $ip }
  set a1 [expr $ip >> 24]
  set ip [expr $ip - ($a1 << 24)]
  set a2 [expr $ip >> 16]
  set ip [expr $ip - ($a2 << 16)]
  set a3 [expr $ip >> 8]
  set ip [expr $ip - ($a3 << 8)]
  return "${a1}.${a2}.${a3}.$ip"
}

### /dcc chat bot
proc mc:chat {n uh h d k a} {
  global mctn mctp mcnt col
  set a [split $a]
  if {[string tolower [lindex $a 0]]!="chat" || [validuser $h]} { *ctcp:server:DCC $n $uh $h $d $k [join $a]; return 1 }
  set id [mc:makeid $n]
  if {![mc:userexists $id]} { *ctcp:server:DCC $n $uh $h $d $k [join $a]; return 1 }
  putlog "$col(hcyn)<$col(cyn)telnet$col(hcyn)>$col(cl) DCC request from $col(mag)$n@$uh$col(cl). \([mc:ip2host [lindex $a 2]]\)"
  if {![catch {set idx [connect [lindex $a 2] [lindex $a 3]]}]} {
    set mctn($idx) ""
    set mctp($idx) ""
    control $idx mc:telnet
    mc:telnet $idx $n
  }
  return 1
}

###  
proc mc:tel {idx} {
    global mc mctn mctp mcnt

    set mctn($idx) ""
    set mctp($idx) ""
    control $idx mc:telnet
}

###   !dcc
proc mc:ttel {idx} {
    global mc mctn mctp mcnt nick

    set mctn($idx) ""
    set mctp($idx) ""
    control $idx mc:telnet
    putidx $idx "Nickname?\r"
}

###     <res>     
proc mc:killdccuser {id res} {
   global mctn mctp mcnt

   if {![array exist mcnt] || ![info exist mcnt($id)]} { return }
   set idx $mcnt($id)
   putidx $idx "Killed. Reason: $res\r"
   unset mctn($idx)
   unset mctp($idx)
   unset mcnt($id)
   killdcc $idx
}

proc mc:telnet {idx arg} {
    global mc mctn mctp mcs mcnt nick liv mcoptions col

    if {[lindex [split $arg] 0] == "USER"} { return }
    if {$arg == ""} {
        putlog "$col(hcyn)<$col(cyn)telnet$col(hcyn)>$col(cl) Colosed from $col(mag)$mctn($idx)$col(cl) at idx $col(mag)$idx$col(cl)."
        unset mctn($idx)
        unset mctp($idx)
        return
    }
    ###  
    if { $mctn($idx) == "" } {
        if {[lindex [ms:fl $arg] 0] == "100"} {
            ###     
            putidx $idx "101 $nick"
            set id [tolower [lindex [ms:fl $arg] 1]]
        } else {
            ###     !dcc
            set id [tolower [lindex [ms:fl $arg] 0]]
        }
        putlog "$col(hcyn)<$col(cyn)telnet$col(hcyn)>$col(cl) Try ident $col(mag)[lindex [ms:fl $arg] end]$col(cl)."
        if {[info exist mcs($id)]} {
            set mctn($idx) $id
            set mcnt($id) $idx
            putidx $idx "Arena Password?\r"
        } else {
            putidx $idx "No such nick.\r"
            killdcc $idx
            unset mctn($idx)
            unset mctp($idx)
        }
        return
    }
    ###  
    if { $mctp($idx) == "" } {
        set id $mctn($idx)
        if { [mc:getstat pass $id] == [md5 $arg] } {
            ###  DCC    
            foreach tid [array names mctn] {
                if { $mctn($idx) == $mctn($tid) && $idx != $tid } {
#                    putlog "TLN: !$idx!$id! - kill clone!$tid!"
                    putidx $tid "New DCC open.\r"
                    unset mcnt($mctn($tid))
                    unset mctn($tid)
                    unset mctp($tid)
                    killdcc $tid
                }
            }
            set mctn($idx) $id
            set mcnt($id) $idx
            set mctp($idx) $arg

            if { [mc:telnet:checkclone $idx] } {
#                putlog "TLN: !$idx!$id! - host clones"
                putidx $idx "No allow more DCC-Chats from this host.\r"
                unset mctn($idx)
                unset mcnt($id)
                unset mctp($idx)
                killdcc $idx
                return
            }

            putidx $idx "You are logged.\r"
            putlog "$col(hcyn)<$col(cyn)telnet$col(hcyn)>$col(cl) Logged $col(mag)$id$col(cl) at idx $col(mag)$idx$col(cl)."
            if { $mc(phase) >= 1 && [info exists liv($id)] } {
                mc:createlist
                set mcoptions(sendlist) 1
                foreach ls [mc:list [mc:modeok $id "exlist"]] {
                    mc:msg $id $ls
                }
                set mcoptions(sendlist) 0
            }
        } else {
            if {[mc:getstat pass $id] == "-disable-"} {
              set reason "Nick disabled."
            } elseif {[string range [mc:getstat pass $id] 0 1]=="->"} {
              set reason "Nick transfered to bot <[string range [mc:getstat pass $id] 2 end]>."
            } else {
              set reason "Bad password."
            }
            putidx $idx "$reason\r"
            putlog "$col(hcyn)<$col(cyn)telnet$col(hcyn)>$col(cl) Killed $col(mag)$id$col(cl). $reason"
            unset mcnt($mctn($idx))
            unset mctn($idx)
            unset mctp($idx)
            killdcc $idx
        }
        return
    }
    foreach ee [binds "*mc:*"] {
        if { [lindex $ee 0] != "msgm" && [lindex $ee 0] != "msg" } { continue }

        set command ""
        if { [string match -nocase [lindex $ee 2] [stripspec $arg]] } {
            set command [stripspec $arg]
        } elseif { [string length [string trimleft [lindex $ee 2] "!"]] > 1 && [string match -nocase [string trimleft [lindex $ee 2] "!"] [stripspec $arg]] } {
            set command [lindex $ee 2]
        }

        if { $command != "" } {
          if { [lindex $ee 1] == "-|-" } {
            eval "[lindex $ee 4] {[stripspec [ms:dfl [ms:dfl $mctn($idx)]]]} {telnet@telnet} {nohandle} {[stripspec $arg]}"
          } else {
            putidx $idx "10     DCC.\r"
          }
        }
    }
    putloglev m *0 "$col(hblk)\[$col(hgrn)[ms:dfl [mc:getstat nick $mctn($idx)]]$col(hblk)\($col(grn)dcc$col(hblk)\)\]$col(cl) $arg"
}

proc mc:arenadcc {h i a} {
    global mc mctn mctp

    set addc "IDX\(%.3d\) %-20s - IDLE: %5dsec - %s \[%s, %s\]"

    foreach idx [dcclist] {
        if { [lindex $idx 1] == "*" && [lindex $idx 3] == "SCRIPT" && [lindex [lindex $idx 4] 1] == "mc:telnet" } {
            if { [info exists mctn([lindex $idx 0])] } {
                 set ids([lindex $idx 0]) "[string range [lindex $idx 2] [expr [string first "@" [lindex $idx 2]] + 1] end] [lindex $idx 5]"
            }
        }
    }

    if {[array size mctn]==0} {
      putlog "Arena DCC-list empty."
      return
    }

    putlog "Arena DCC-List:"
    foreach id [array names mctn] {
        set logged "04Not logged"
        if {$mctp($id) != ""} { set logged "Logged" }
        putlog "[format $addc $id [ms:dfl $mctn($id)] [getdccidle $id] $logged [mc:ip2host [lindex $ids($id) 0]] [lindex $ids($id) 1]]"
    }
    putlog "End of DCC-List"
    putlog "Use .killadcc to kill \"04Not logged\" users."
}

proc mc:killarenadcc {h i a} {
    global mc mcnt mctn mctp

    putlog "Kill \"Not logged\" connections."
    foreach id [array names mctn] {
        if {$mctp($id) == ""} {
            if {[info exist mcnt($mctn($id))]} { unset mcnt($mctn($id)) }
            unset mctn($id)
            unset mctp($id)
            killdcc $id
        }
    }
}

proc mc:akill {h i a} {
    global mc mcnt mctn mctp

    set id [mc:makeid $a]
    putlog "Try to kill ADCC \"[ms:dfl $id]\""

    foreach tid [array names mctn] {
        if { [string match $id $mctn($tid)] } {
            putlog "ADCC [ms:dfl $mctn($tid)]($tid) killed."
            unset mctn($tid)
            unset mctp($tid)
            killdcc $tid
            if { [info exist mc(ident)] && [lsearch -exact $mc(ident) $tid] != -1 } {
                set nn [lsearch -exact $mc(ident) $itid]
                set mc(ident) [lreplace $mc(ident) $nn $nn]
            }
        }
    }
}

proc mc:telnet:checkclone {idx} {
    global mc mcs mctn mctp mcnt mchost

    foreach idxx [dcclist] {
        if { [lindex $idxx 1] == "*" && [lindex $idxx 3] == "SCRIPT" && [lindex [lindex $idxx 4] 1] == "mc:telnet" } {
            if { [info exists mctn([lindex $idxx 0])] } {
                 set ids([lindex $idxx 0]) [string range [lindex $idxx 2] [expr [string first "@" [lindex $idxx 2]] + 1] end]
            }
        }
    }

    if { ![info exists ids($idx)] } { return }

    ### -=-=-=- <   > -=-=-=-
    set found 0
    set may 1
    set num 0
    if { [array exists mchost] } {
        foreach host [array names mchost] {
            set hh [string range [lindex $mchost($host) 0] [expr [string first "@" [lindex $mchost($host) 0]] + 1] end]

            if { [string match $hh $ids($idx)] } {
                set num $host
                break
            }
        }
    }
    if { $num != 0 } { set may [lindex $mchost($num) 1] }
    set mask $ids($idx)

    if { [array exists ids] } {
        foreach idxx [array names ids] {
            if { [string match $mask $ids($idxx)] } {
                incr found
            }
        }
    }

    if { $found > $may } {
        return 1
    }

    return 0
}
