### 0 - comname
### 1 - user list {nick access}
### 2 - games num
### 3 - win num
### 4 - 1/0 - private/public
### 5 - last game time
### 6 - register time

proc mc:user:template {} {
  set ret ""
### 0 3 {nick pass com ?comadd?}
  lappend ret "nick -nopass- - 0"
### 1 7 {race prof sex ptitle title trace regstr fmaster outcast}
  lappend ret "a w 0 {} {} {} {} 0 0"
### 2 10 {remort level exp gold favor nodrop noexp hold mode skp}
  lappend ret "0 1 0 0 0 0 0 0 {auto-ready} 0"
### 3 7 {rstr rdex rwis rint rcon free hbase}
  lappend ret "0 0 0 0 0 0 0"
### 4 4 {eq w eset inv}
  lappend ret "{{waa 0 1 a {}}} {0 -} 0 {}"
### 5 3 {bonus {magic} {skill}}
  lappend ret "0 {{- -}} {{- -}}"
### 6 7 {game win poll ctime ltime run death}
  lappend ret "0 0 0 0 0 0 0"
}

#  
proc lfilter {strname filter} {
  upvar $strname str
  foreach fl $filter {
    if { [set idx [lsearch -exact $str $fl]] != -1 } {
      set str [lreplace $str $idx $idx]
    }
  }
  return $str
}

#    
proc lrandom {l {def ""}} {
  if { $l == "" } { return $def }
  return [lindex $l [rand [llength $l]]]
}

#  join
proc mc:smartjoin {l j1 j2} {
  if { [llength $l] < 2 } {
    return [lindex $l 0]
  } elseif { [llength $l] == 2 } {
    return [join $l $j2]
  } else {
    return [join "{[join [lrange $l 0 [expr [llength $l] - 2]] $j1]} {[lindex $l end]}" $j2]
  }
}

#           "#" -    
proc mc:stripline {v} {
  upvar $v vr
  if {[string length $vr]==0} { return }
  set vr [string trimleft $vr]
  if {[string first "#" $vr]==0} { set vr "" }
}

#     
#   ton -   (/)
#   frm -   
#   lst -       frm    irc
#   alst -    lst     irc
#   jn   -   join.   - lst   
#   islast
proc mc:out {ton frm lst alst jn} {
  upvar $lst onout
  set tmpout $onout
  lappend tmpout $alst
  set tmpout [join $tmpout $jn]
  if {[string length [format $frm $tmpout]]>250} {
    set onout [join $onout $jn]
    if { $ton == "-" || $ton == "" } {
      mc:say [format $frm $onout]
    } else {
      mc:msg $ton [format $frm $onout]
    }
    putlog "jout: $onout"
    set onout ""
  }
  lappend onout $alst
}

proc mc:lastout {ton frm lst jn} {
  upvar $lst onout
  if {$onout==""} { return }
  set onout [join $onout $jn]
  if { $ton == "-" || $ton == "" } {
    mc:say [format $frm $onout]
  } else {
    mc:msg $ton [format $frm $onout]
  }
}

proc mc:userexists {id} {
   global mcs
   return [info exist mcs($id)]
}

proc mc:makeid {n} {
    return [tolower [ms:fl $n]]
}

proc mc:check {id t} {
    global mc mcs

    if { $mc(phase) == -1 || ($t != "-" && $mc(phase) != $t) } { return 0 }
    if { ![info exists mcs($id)] } { return 0 }

    return [mc:checkident $id]
}

proc mc:checkident {id} {
    global mc ct mctn

    if { [mc:getstat pass $id] == "-nopass-" } { return 1 }
    if { [string index [mc:getstat pass $id] 0] == "-" } { return 0 }
    if { ![mc:chkflag isident] } { return 1 }
    if { ![info exist mc(ident)] || [lsearch -exact $mc(ident) $id] == -1 } {
        if { [array exist mctn] } {
            foreach nn [array names mctn] {
                if { $mctn($nn) == $id } {
                    return 1
                }
            }
        }

       # putserv "NOTICE [mc:getstat nick $id] :$ct(0)"
        if {[mc:modeok $id "priv-warn"]} {
          mc:msg [ms:dfl [mc:getstat nick $id]] $ct(0)
        } {
          mc:notice [ms:dfl [mc:getstat nick $id]] $ct(0)
        }
        return 0
    }

    return 1
}

proc mc:mver {n uh h t}   { mc:ver $n }
proc mc:pver {n uh h c t} { mc:ver $n }

proc mc:ver {nick} {
    global mc version admin

    puthelp "NOTICE $nick :[format $mc(cop) $mc(ver)]. Channel: $mc(chan). BotAdmin: $admin."
}

#      
proc mc:calcaveragelevel {} {
    global mc mcs

    set count 1
    set summa 0
    set mc(averagelevel) 0
    foreach id [array names mcs] {
        if {[string range $id 0 3]=="fuck"} { continue }
        incr count
        set summa [expr $summa + [mc:getstat level $id] + [mc:getstat remort $id]]
    }
    set mc(averagelevel) [expr round($summa * 2.0 / $count)]
    putlog "AverageLevel: $mc(averagelevel), Count: $count, Summa: $summa"
}

###      
proc mc:numending {arg mode suf1 suf2 suf3} {
    set num2 [string range $arg end-1 end]
    set num1 [string index $arg end]

    if {![isnumber $arg]} { return }

    if { $mode == 1 } {
        switch -- $num1 {
            0 { set suffix $suf1 }
            1 { set suffix $suf1 }
            2 { set suffix $suf2 }
            3 { set suffix $suf3 }
            4 { set suffix $suf1 }
            5 { set suffix $suf1 }
            6 { set suffix $suf2 }
            7 { set suffix $suf2 }
            8 { set suffix $suf2 }
            9 { set suffix $suf1 }
        }
        if {$num2 > 10 && $num2 <= 20} {
            set suffix $suf1
        }
    } elseif { $mode == 2 } {
        switch -- $num1 {
            0 { set suffix $suf1 }
            1 { set suffix $suf2 }
            2 { set suffix $suf3 }
            3 { set suffix $suf3 }
            4 { set suffix $suf3 }
            5 { set suffix $suf1 }
            6 { set suffix $suf1 }
            7 { set suffix $suf1 }
            8 { set suffix $suf1 }
            9 { set suffix $suf1 }
        }
        if {$num2 > 10 && $num2 <= 20} {
            set suffix $suf1
        }
    }

    return $suffix
}

proc mc:adjending {number} {
    if {![isnumber $number] || $number > 999} { return }

    set del [split $number ""]

    set unit(0)  ""
    set unit(1)  ""
    set unit(2)  ""
    set unit(3)  ""
    set unit(4)  ""
    set unit(5)  ""
    set unit(6)  ""
    set unit(7)  ""
    set unit(8)  ""
    set unit(9)  ""
    set unit(11) ""
    set unit(12) ""
    set unit(13) ""
    set unit(14) ""
    set unit(15) ""
    set unit(16) ""
    set unit(17) ""
    set unit(18) ""
    set unit(19) ""

    set ten(00) ""
    set ten(0)  ""
    set ten(10) ""
    set ten(1)  ""
    set ten(20) ""
    set ten(2)  ""
    set ten(30) ""
    set ten(3)  ""
    set ten(40) ""
    set ten(4)  ""
    set ten(50) ""
    set ten(5)  ""
    set ten(60) ""
    set ten(6)  ""
    set ten(70) ""
    set ten(7)  ""
    set ten(80) ""
    set ten(8)  ""
    set ten(90) ""
    set ten(9)  ""

    set hundred(10) ""
    set hundred(1)  ""
    set hundred(20) ""
    set hundred(2)  ""
    set hundred(30) ""
    set hundred(3)  ""
    set hundred(40) ""
    set hundred(4)  ""
    set hundred(50) ""
    set hundred(5)  ""
    set hundred(60) ""
    set hundred(6)  ""
    set hundred(70) ""
    set hundred(7)  ""
    set hundred(80) ""
    set hundred(8)  ""
    set hundred(90) ""
    set hundred(9)  ""

    for {set i [expr [llength $del] - 1]} {$i >= 0} {incr i -1} {
        set list([expr [llength $del] - $i]) [lindex $del $i]
    }

    set out $unit($list(1))

    if {$number > 9} {
        if {$list(2) == 1 && $list(1) != 0} {
            set out $unit(1$list(1))
        }
        if {$list(1) == 0} {
            set out $ten($list(2)0)
        }
        if {$list(1) != 0} {
            if {$ten($list(2)) != ""} {
                set out "$ten($list(2)) $out"
            }
        }
    }
    if {$number > 99} {
        if {$list(1) == 0 && $list(2) == 0} {
            set out $hundred($list(3)0)
        }
        if {$list(1) == 0 && $list(2) != 0} {
            set out "$hundred($list(3)) $out"
        }
        if {$list(1) != 0} {
            if {$hundred($list(3)) != ""} {
                set out "$hundred($list(3)) $out"
            }
        }
    }

    return $out
}

proc mc:magicapply {id magic} {
    global mr
    set bonus 0
    set level [string index $magic 0]

    set level [expr $level * 2 - 1]
    #putlog "2level = $level, [mc:getstat level $id]"
    if { $level >= [mc:getstat level $id] } { return 0 }

    if { [mc:getstat prof $id] == "m" } {
        set bonus [format "%.2f" [expr [mc:getstat wis $id] * 0.4 / 30.0 + [mc:getstat int $id] * 0.6 / 30.0 * (1 + $mr(${magic}f)) / $level]]
    } elseif {[mc:getstat prof $id] == "p"} {
        set bonus [format "%.2f" [expr [mc:getstat wis $id] * 0.6 / 30.0 + [mc:getstat int $id] * 0.4 / 30.0 * (1 + $mr(${magic}f)) / $level]]
    }
#    putlog "MEffApply for $magic for [ms:dfl [mc:getstat nick $id]] = $bonus (wis = [mc:getstat wis $id], int = [mc:getstat int $id], mf = $mr(${magic}f))"

    return $bonus
}

proc mc:expapply {id targ {type ""}} {
    set apply 1.00

    if { $id == $targ } { return $apply }
    set idstr [max [expr [mc:getstat strength $id]   + [mc:getstat remort $id]   * 7 - [mc:getstat level $id]   * 6] 0.01]
    set tgstr [max [expr [mc:getstat strength $targ] + [mc:getstat remort $targ] * 7 - [mc:getstat level $targ] * 6] 0.01]
    set koof  [expr 1.0 * $idstr / $tgstr]

    switch -- $type {
      bad {
        set apply [expr $apply + [mc:round:var expup $targ]]
        if { $koof > 1 } {
          set apply [expr $apply - 0.1 * $koof]
        }
      }
      good {
        set apply [max [expr $apply - [mc:round:var expup $targ]] 0.01]
      }
    }

    return [min [max $apply 0.01] 2]
}

#      
proc mc:allrace {} {
    global race
    set temp ""
    foreach ra [array names race] {
        set temp [lappend temp $ra]
    }
    set temp [lsort -ascii $temp]
    set temp [join $temp]
    regsub -all "\[\[:space:\]\]" $temp "" temp
    return $temp
}

#      ,  $not
proc mc:notrace {not} {
    set temp [mc:allrace]
    for {set i 0} {$i < [string length $not]} {incr i} {
        regsub -all [string index $not $i] $temp "" temp
    }
    return $temp
}

#      
proc mc:allprof {} {
    global prof
    set temp ""
    foreach pr [array names prof] {
        set temp [lappend temp $pr]
    }
    set temp [lsort -ascii $temp]
    set temp [join $temp]
    regsub -all "\[\[:space:\]\]" $temp "" temp
    return $temp
}

#      ,  $not
proc mc:notprof {not} {
    set temp [mc:allprof]
    for {set i 0} {$i < [string length $not]} {incr i} {
        regsub -all [string index $not $i] $temp "" temp
    }
    return $temp
}

proc mc:mod {id n w} {
    global mcs
    set mcs($id) [lreplace $mcs($id) $n $n [expr [lindex $mcs($id) $n] + $w]]
}
proc mc:modset {id n w} {
    global mcs
    set mcs($id) [lreplace $mcs($id) $n $n $w]
}
proc mc:modget {id n} {
    global mcs
    return [lindex $mcs($id) $n]
}
proc mc:mcom {id n w} {
    global mco
    set mco($id) [lreplace $mco($id) $n $n [expr [lindex $mco($id) $n] + $w]]
}
proc mc:mcomset {id n w} {
    global mco
    set mco($id) [lreplace $mco($id) $n $n $w]
}
proc mc:mcomget {id n} {
    global mco
    return [lindex $mco($id) $n]
}

# ---------------------------------------- STAT ----------------------------------------

proc mc:utils:heal2real {hl {txt 0}} {
  set tmph "[expr2 2 0.1 * $hl * 5 / 5]x[expr2 2 0.1 * $hl * 7 / 5]"
  if { $txt } { return $tmph }
  return [expr2 2 [mc:diex $tmph]]
}

proc mc:utils:getatcprt {id vat vpr vwr vma vmp vhl vmn vha vsp vmb vdd} {
  global weaponweight thicoll

#  
  upvar $vat wat
#  
  upvar $vpr wpr
#  .
  upvar $vsp wspr
#  
  upvar $vwr wearp
#  
  upvar $vma mga
#  
  upvar $vmp mgp
#  
  upvar $vhl hel
#  
  upvar $vmn man
#   . 
  upvar $vha had
#  
  upvar $vmb mbn
#   
  upvar $vdd dmgdownprc

  set wearp ""
  set wspr  0.0
  set dmgdownprc 0
  set prof  [mc:getstat prof $id]

  if { [mc:user:longweapon $id] } {
#    set wat [expr 1.0 * ([mc:getstat dex $id] * 0.6) + ([mc:getstat int $id] * 0.3)]
#    set mga [expr2 2 1.0 * ([mc:getstat wis $id] + [mc:getstat int $id]) / 3.0]
#    set mgp [expr2 2 1.0 * ([mc:getstat wis $id] + [mc:getstat int $id]) / 3.0]
#    set hel [expr 1.0 * [mc:getstat wis $id] * 0.3 + [mc:getstat int $id] * 0.3]
#    set had [expr2 2 1.0 * [mc:getstat int $id] / (4.0 + [mc:getstat remort $id])]

    set wat [expr 1.0 * [mc:getstat dex $id] * 0.6 + [mc:getstat int $id] * 0.3]
    set had [expr2 2 1.0 * [mc:getstat int $id] / 4.0]
  } else {
    if { $prof == "m" } {
#      set mga [expr 1.0 * [mc:getstat wis $id] * 0.4 + [mc:getstat int $id] * 0.6]
#      set mgp [expr 1.0 * [mc:getstat wis $id] * 0.4 + [mc:getstat int $id] * 0.6]
#      set hel [expr 1.0 * [mc:getstat wis $id] * 0.4 + [mc:getstat int $id] * 0.5]
#      set had [expr 1.0 * [mc:getstat str $id] / 10.0]
    } elseif { $prof == "p" } {
#      set mga [expr 1.0 * [mc:getstat wis $id] * 0.6 + [mc:getstat int $id] * 0.4]
#      set mgp [expr 1.0 * [mc:getstat wis $id] * 0.6 + [mc:getstat int $id] * 0.4]
#      set hel [expr 1.0 * [mc:getstat wis $id] * 0.6 + [mc:getstat int $id] * 0.6]
#      set had [expr 1.0 * [mc:getstat str $id] / 10.0]
    } else {
#      set mga [expr 1.0 * ([mc:getstat wis $id] + [mc:getstat int $id]) / 2.0]
#      set mgp [expr 1.0 * ([mc:getstat wis $id] + [mc:getstat int $id]) / 2.0]
#      set hel [expr 1.0 * [mc:getstat wis $id] * 0.3 + [mc:getstat int $id] * 0.3]
#      set had [expr2 2 1.0 * [mc:getstat str $id] / (4.0 + [mc:getstat remort $id])]
    }

    set had [expr2 2 1.0 * [mc:getstat str $id] / 4.0]
    set wat [expr 1.0 * [mc:getstat dex $id] * 0.6 + [mc:getstat str $id] * 0.3]
  }
  set wpr [expr 1.0 * [mc:getstat dex $id] * 0.3 + [mc:getstat con $id] * 0.6]

### --------------------------------------------------
  set mga [expr2 2 1.0 * [mc:getstat wis $id] * 0.4 + [mc:getstat int $id] * 0.6]
  set mgp [expr2 2 1.0 * [mc:getstat wis $id] * 0.6 + [mc:getstat int $id] * 0.4]
  set hel [expr2 2 1.0 * [mc:getstat wis $id] * 0.5 + [mc:getstat int $id] * 0.5]
  set man [expr2 1 0.4 * ([mc:getstat wis $id] * 0.4 + [mc:getstat int $id] * 0.6)]
### --------------------------------------------------

  ###     
  set idweapon [mc:getstat wield $id]
  foreach thii [mc:getstat xeq $id] {
    set wat  [expr $wat   + [mc:wget [lindex $thii 1] atc  $id]]
    set wpr  [expr $wpr   + [mc:wget [lindex $thii 1] prt  $id]]
    set wspr [expr $wspr  + [mc:wget [lindex $thii 1] sprt $id]]
    set dmgdownprc [expr $dmgdownprc + [mc:wget [lindex $thii 1] dmgdownprc $id]]
    if { [lsearch -exact $idweapon [lindex $thii 1]] != -1 } {
      set wearp [lappend wearp [lindex $thii 1]]
    }
  }

  ###     
  foreach col [array names thicoll] {
    if { ![mc:fullcoll $id $col] } { continue }
    set wat  [expr $wat  + [mc:wgetcoll $col atc ]]
    set wpr  [expr $wpr  + [mc:wgetcoll $col prt ]]
    set wspr [expr $wspr + [mc:wgetcoll $col sprt]]
    set dmgdownprc [expr $dmgdownprc + [mc:wgetcoll $col dmgdownprc]]
  }

  set wmod 0
  if { [llength $wearp] > 1 } {
    foreach weapon $wearp {
      if { [mc:wget $weapon atcmod $id] > 0 } {
        set wmod [expr $wmod + [lindex $weaponweight([mc:wget $weapon atcmod $id]) 0]]
      }
    }
    if {[set wmod [expr 1.0 * $wmod / [llength $wearp]]] > 0} {
      set wat [expr 1.0 * $wat / $wmod]
    }
  }

  foreach tal [mc:getstat inv $id] {
    set tid [lindex $tal 0]
    set tcount [expr [llength $tal] - 1]
    if { $tcount <= 0 } { continue }

    switch -- $tid {
      zaa {
        ### (t)  
        set hits [expr $tcount * [mc:wgettal $tid param1]]
        set wat [expr $wat + $hits]
      }
      zab {
        ### (t)  
        set hits [expr $tcount * [mc:wgettal $tid param1]]
        set wpr [expr $wpr + $hits]
      }
    }
  }

  set wat [max [expr2 1 $wat] 1.0]
  set wpr [max [expr2 1 $wpr] 1.0]
  set mga [max [expr2 1 $mga] 1.0]
  set mgp [max [expr2 1 $mgp] 1.0]

  set pys [expr 0.5 * ($wat + $wpr)]
  set mag [expr 0.5 * ($mga + $mgp)]

  if { $pys < 30 } {
    set mbn 1.0
  } elseif { $pys > 120 } {
    set mbn 0.1
  } else {
    set mbn [expr 1.3 - 0.01 * $pys]
  }

  set dmgdownprc [expr2 2 0.01 * $dmgdownprc]

  return "$wat $wpr {$wearp}"
}

#    <id>
#   race : 
#   prof : 
proc mc:_getstat {val id} {
  global race prof

  switch -- $val {
    "race" {
      return [lindex [lindex $race([mc:getstat race $id]) 0] [mc:getstat sex $id]]
    }
    "prof" {
      if { [set tprf [mc:getstat prof $id]] == "w" } {
        if { [mc:user:longweapon $id] } {
          set tprf "l"
        }
      }
      return [lindex $prof($tprf) 0]
    }
  }
}

proc mc:getstat {stat id {add ""}} {
    global mcs

    set id [mc:makeid $id]
    if {$id == "-fuck"} { return -1 }
    if { $add == "txt" } { return [mc:_getstat $stat $id] }
    set temp 0

    switch -- $stat {
        nick    { return [lindex [lindex $mcs($id) 0] 0] }
        pass    { return [lindex [lindex $mcs($id) 0] 1] }
        com     { return [lindex [lindex $mcs($id) 0] 2] }

        race    { return [lindex [lindex $mcs($id) 1] 0] }
        prof    { return [lindex [lindex $mcs($id) 1] 1] }
        sex     { return [lindex [lindex $mcs($id) 1] 2] }
        ptitle  { return [lindex [lindex $mcs($id) 1] 3] }
        title   { return [lindex [lindex $mcs($id) 1] 4] }
        trace   { return [lindex [lindex $mcs($id) 1] 5] }
        regstr  { return [lindex [lindex $mcs($id) 1] 6] }
        fmaster { return [lindex [lindex $mcs($id) 1] 7] }
        outcast { return [lindex [lindex $mcs($id) 1] 8] }

        remort { return [lindex [lindex $mcs($id) 2] 0] }
        level  { return [lindex [lindex $mcs($id) 2] 1] }
        exp    { return [lindex [lindex $mcs($id) 2] 2] }
        gold   { return [lindex [lindex $mcs($id) 2] 3] }
        favor  { return [lindex [lindex $mcs($id) 2] 4] }
        nodrop { return [lindex [lindex $mcs($id) 2] 5] }
        noexp  { return [lindex [lindex $mcs($id) 2] 6] }
        hold   { return [lindex [lindex $mcs($id) 2] 7] }
        mode   { return [lindex [lindex $mcs($id) 2] 8] }
        skp    { return [lindex [lindex $mcs($id) 2] 9] }

        rstr   { return [lindex [lindex $mcs($id) 3] 0] }
        rdex   { return [lindex [lindex $mcs($id) 3] 1] }
        rwis   { return [lindex [lindex $mcs($id) 3] 2] }
        rint   { return [lindex [lindex $mcs($id) 3] 3] }
        rcon   { return [lindex [lindex $mcs($id) 3] 4] }
        free   { return [lindex [lindex $mcs($id) 3] 5] }
        hbase  { return [lindex [lindex $mcs($id) 3] 6] }
        str    {
                 set temp [mc:getstat rstr $id]
                 foreach pr [mc:getstat eq $id] {
                     if {([llength [mc:wget [lindex $pr 1] plushark $id]] > 1) && ([lindex $pr 2])} {
                         set temp [expr $temp + [lindex [mc:wget [lindex $pr 1] plushark $id] 0]]
                     }
                 }
                 return [max 0 $temp]
        }
        dex    {
                 set temp [mc:getstat rdex $id]
                 foreach pr [mc:getstat eq $id] {
                     if {([llength [mc:wget [lindex $pr 1] plushark $id]] > 1) && ([lindex $pr 2])} {
                         set temp [expr $temp + [lindex [mc:wget [lindex $pr 1] plushark $id] 1]]
                     }
                 }
                 return [max 0 $temp]
        }
        wis    {
                 set temp [mc:getstat rwis $id]
                 foreach pr [mc:getstat eq $id] {
                     if {([llength [mc:wget [lindex $pr 1] plushark $id]] > 1) && ([lindex $pr 2])} {
                         set temp [expr $temp + [lindex [mc:wget [lindex $pr 1] plushark $id] 2]]
                     }
                 }
                 return [max 0 $temp]
        }
        int    {
                 set temp [mc:getstat rint $id]
                 foreach pr [mc:getstat eq $id] {
                     if {([llength [mc:wget [lindex $pr 1] plushark $id]] > 1) && ([lindex $pr 2])} {
                         set temp [expr $temp + [lindex [mc:wget [lindex $pr 1] plushark $id] 3]]
                     }
                 }
                 return [max 0 $temp]
        }
        con    {
                 set temp [mc:getstat rcon $id]
                 foreach pr [mc:getstat eq $id] {
                     if {([llength [mc:wget [lindex $pr 1] plushark $id]] > 1) && ([lindex $pr 2])} {
                         set temp [expr $temp + [lindex [mc:wget [lindex $pr 1] plushark $id] 4]]
                     }
                 }
                 return [max 0 $temp]
        }

        eq     { return [lindex [lindex $mcs($id) 4] 0] }
        wield  { return [lindex [lindex $mcs($id) 4] 1] }
        eset   { return [lindex [lindex $mcs($id) 4] 2] }
        inv    { return [lindex [lindex $mcs($id) 4] 3] }

        bonus  { return [lindex [lindex $mcs($id) 5] 0] }
        magic  { return [lindex [lindex $mcs($id) 5] 1] }
        skill  { return [lindex [lindex $mcs($id) 5] 2] }

        game   { return [lindex [lindex $mcs($id) 6] 0] }
        win    { return [lindex [lindex $mcs($id) 6] 1] }
        poll   { return [lindex [lindex $mcs($id) 6] 2] }
        ctime  { return [lindex [lindex $mcs($id) 6] 3] }
        ltime  { return [lindex [lindex $mcs($id) 6] 4] }
        run    { return [lindex [lindex $mcs($id) 6] 5] }
        death  { return [lindex [lindex $mcs($id) 6] 6] }

        xeq    {
          set ret ""
          set wlist [mc:getstat wield $id]
          foreach wrec [mc:getstat eq $id] {
            if { [lindex $wrec 2] == 0 } continue
            if { [mc:wget [lindex $wrec 1] weapon $id] != 0 && [lsearch -exact $wlist [lindex $wrec 1]] == -1 } continue
            lappend ret $wrec
          }
          return $ret
        }

        manaprc {
          set ret 1.0
          foreach tal [mc:getstat inv $id] {
            set tid [lindex $tal 0]
            set tcount [expr [llength $tal] - 1]
            if { $tcount <= 0 } { continue }
            switch -- $tid {
              zad {
              ### (t)  
                set ret [expr $ret - [expr $tcount * [mc:wgettal $tid param1] * 0.01]]
                if { $ret < 0.1 } { set ret 0.1 }
              }
            }
          }
          return $ret
        }

        hlong {
            if { [string first [mc:getstat prof $id] "mp"] == -1 } { return 0 }
            return [max 1 [expr int([mc:getstat int $id] / (4 + 0.1 * [mc:getstat level $id]))]]
        }

        maxtarg {
            if { ![mc:user:longweapon $id] } { return 0 }
            return [max 1 [expr round(([mc:getstat wis $id] * 0.7 + [mc:getstat str $id] * 0.3) / 4.0)]]
        }

        maxcast {
            if { [mc:getstat prof $id] != "p" } { return 0 }
            return [max 1 [expr round(([mc:getstat wis $id] * 0.5 + [mc:getstat int $id] * 0.5) / ([mc:getstat level $id] + 10.0))]]
        }

        strength {
            return [expr [lindex [lindex $mcs($id) 3] 0] + [lindex [lindex $mcs($id) 3] 1] + [lindex [lindex $mcs($id) 3] 2] + [lindex [lindex $mcs($id) 3] 3] + [lindex [lindex $mcs($id) 3] 4] + [lindex [lindex $mcs($id) 3] 5]]
        }

        maxhp {
          set ret [mc:getstat rmaxhp $id]
          foreach ee [mc:getstat xeq $id] {
              set ret [expr $ret + [mc:wget [lindex $ee 1] maxhp $id]]
          }
          foreach col [mc:collect:list] {
            if { ![mc:fullcoll $id $col] } { continue }
            set ret [expr $ret + [mc:wgetcoll $col maxhp]]
          }
          return $ret
        }

        rmaxhp {
          return [expr2 2 [mc:getstat hbase $id] + 1.0 * [mc:getstat rcon $id] / 3]
        }

        roundprc {
            return [expr2 0 100 + [mc:getstat remort $id] * 5]
        }

        default {
            putlog "Error in MC:GetStat. Stat - $stat"
            return "#error#"
        }
    }
    return
}

proc mc:setstat {stat id set} {
    global mcs

    set id [mc:makeid $id]
    if {$id == "-fuck"} { return -1 }
    set temp ""

    switch -- $stat {
        nick   {
                 set temp [lindex $mcs($id) 0]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 0 0 $temp]
        }
        pass   {
                 set temp [lindex $mcs($id) 0]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 0 0 $temp]
        }
        com    {
                 set temp [lindex $mcs($id) 0]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 0 0 $temp]
        }

        race   {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        prof   {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        sex    {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        ptitle {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 3 3 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        title  {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 4 4 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        trace  {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 5 5 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        regstr {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 6 6 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        fmaster {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 7 7 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        outcast {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 8 8 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }

        remort {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        level  {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        exp    {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        gold   {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 3 3 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        favor  {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 4 4 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        nodrop {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 5 5 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        noexp  {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 6 6 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        hold   {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 7 7 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        mode   {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 8 8 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        skp  {
                 set temp [lindex $mcs($id) 2]
                 while {[llength $temp]<10} { lappend temp 0 }
                 set temp [lreplace $temp 9 9 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }

        str    {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        dex    {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        wis    {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        int    {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 3 3 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        con    {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 4 4 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        free   {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 5 5 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        hbase  {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 6 6 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }

        eq     {
                 set temp [lindex $mcs($id) 4]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 4 4 $temp]
        }
        wield  {
                 set temp [lindex $mcs($id) 4]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 4 4 $temp]
        }
        eset   {
                 set temp [lindex $mcs($id) 4]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 4 4 $temp]
        }
        inv    {
                 set temp [lindex $mcs($id) 4]
                 set temp [lreplace $temp 3 3 $set]
                 set mcs($id) [lreplace $mcs($id) 4 4 $temp]
        }

        bonus  {
                 set temp [lindex $mcs($id) 5]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 5 5 $temp]
        }
        magic  {
                 set temp [lindex $mcs($id) 5]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 5 5 $temp]
        }
        skill  {
                 set temp [lindex $mcs($id) 5]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 5 5 $temp]
        }

        game   {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        win    {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        poll   {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        ctime  {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 3 3 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        ltime  {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 4 4 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        run    {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 5 5 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        death  {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 6 6 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }

        default {
            putlog "Error in MC:SetStat. Stat - $stat"
            return "#error#"
        }
    }
    return
}

# ---------------------------------------- /STAT ----------------------------------------

proc mc:getmaxhp {id} {
    global thi thicoll

    set mhp [expr [mc:getstat hbase $id] + 1.0 * [mc:getstat con $id] / 3]

    foreach ee [mc:getstat eq $id] {
        if { [lindex $ee 2] == 1 } { set mhp [expr $mhp + [mc:wget [lindex $ee 1] maxhp $id]] }
    }
    foreach col [array names thicoll] {
        if { ![mc:fullcoll $id $col] } { continue }
        set mhp [expr $mhp + [mc:wgetcoll $col maxhp]]
    }

    return [format "%.2f" $mhp]
}
proc mc:getrmaxhp {id} {
    return [format "%.2f" [expr [mc:getstat hbase $id] + 1.0 * [mc:getstat rcon $id] / 3]]
}
proc mc:getmaxmp {id} {
    global thicoll

    set mmp [expr [mc:getstat wis $id] * 1.5]
#    set mmp [expr [mc:getstat wis $id] / (0.5 + 0.1 * [mc:getstat remort $id])]

    foreach ee [mc:getstat eq $id] {
        if { [lindex $ee 2] == 1 } { set mmp [expr $mmp + [mc:wget [lindex $ee 1] maxmp $id]] }
    }
    foreach col [array names thicoll] {
        if { ![mc:fullcoll $id $col] } { continue }
        set mmp [expr $mmp + [mc:wgetcoll $col maxmp]]
    }

    return [format "%.2f" $mmp]
}
proc mc:getrmaxmp {id} {
#    return [format "%.2f" [expr [mc:getstat rwis $id] / (0.5 + 0.1 * [mc:getstat remort $id])]]
    return [format "%.2f" [expr [mc:getstat rwis $id] * 1.5]]
}

#---------------------- Loaders ---------------------------------

proc mc:prof:load {} {
  global mc prof race

  putlog "Loading profs&races..."
  if {[array exist prof]} { unset prof }
  if {[array exist race]} { unset race }
  if {![file exists "$mc(file.prof).conf"]} {
    putlog "Warning! Prof&race file \($mc(file.prof).conf\) not found."
    return
  }

  set defprof {Gluck 1 1 1 1 1 1.0 0 0 0 0 0 0 0 4000.0 "{- -}" "{- -}" gluck}
  set defrace {{Gluck Gluck Gluck Gluck} 0 0 0 0 0}
  set curprof ""
  set currace ""
  set curdata ""
  set fid [open "$mc(file.prof).conf" r]
  while {![eof $fid]} {
    gets $fid line
    mc:stripline line
    if {[llength [split $line]]<2 && [string index $line 0] != "\["} { continue }
    if {[join [lindex [split $line] 0]]=="\[prof\]"} {
      set curprof [join [lindex [split $line] 1]]
      set currace ""
      set curdata $defprof
      continue
    } elseif {[join [lindex [split $line] 0]]=="\[endprof\]" && $curprof != ""} {
      set prof($curprof) $curdata
      set curprof ""
      continue
    } elseif {[join [lindex [split $line] 0]]=="\[race\]"} {
      set currace [join [lindex [split $line] 1]]
      set curprof ""
      set curdata $defrace
      continue
    } elseif {[join [lindex [split $line] 0]]=="\[endrace\]" && $currace != ""} {
      set race($currace) $curdata
      set currace ""
      continue
    }
    set line [split $line]
    set param [string trimleft [join [lrange $line 1 end]]]
    if { $curprof != "" } {
      switch -- [lindex $line 0] {
        name     { set curdata [lreplace $curdata 0  0  $param] }
        heals    { set curdata [lreplace $curdata 6  6  $param] }
        gold     { set curdata [lreplace $curdata 7  7  $param] }
        freehark { set curdata [lreplace $curdata 13 13 $param] }
        exp      { set curdata [lreplace $curdata 14 14 $param] }
        weap     { set curdata [lreplace $curdata 17 17 $param] }

        reghark  {
          for { set i 1 } { [llength $param] > [expr $i - 1] } { incr i } {
            set curdata [lreplace $curdata $i $i [lindex $param [expr $i - 1]]]
          }
        }

        bonhark  {
          foreach hrk $param {
            regsub -all \[^0-9\] $hrk "" num
            if { ![isnumber $num] } { continue }
            regsub -all \[^a-z\] $hrk "" hrk
            if { [set hrk [lsearch "str dex wis int con" $hrk]] == -1 } { continue }
            set hrk [expr $hrk + 8]
            set curdata [lreplace $curdata $hrk $hrk $num]
          }
        }

        magic   {
          set mag ""
          foreach mrec [lindex $curdata 16] {
            if { [lindex $mrec 0] != "-" } { lappend mag $mrec }
          }
          foreach mrec $param {
            lappend mag "$mrec 1"
          }
          set curdata [lreplace $curdata 16 16 $mag]
        }
      }
    } elseif { $currace != "" } {
      switch -- [lindex $line 0] {
        name     {
          set names ""
          lappend names $param
          foreach tmpnam [lrange [lindex $curdata 0] 1 end] {
            if { $tmpnam != "Gluck" } { lappend names $tmpnam } { lappend names $param }
          }
          set curdata [lreplace $curdata 0 0 $names]
        }

        namef   { set curdata [lreplace $curdata 0 0 [lreplace [lindex $curdata 0] 1 1 $param]] }
        nameo   { set curdata [lreplace $curdata 0 0 [lreplace [lindex $curdata 0] 2 2 $param]] }
        namea   { set curdata [lreplace $curdata 0 0 [lreplace [lindex $curdata 0] 3 3 $param]] }

        bonhark  {
          foreach hrk $param {
            regsub -all \[^0-9\] $hrk "" num
            if { ![isnumber $num] } { continue }
            regsub -all \[^a-z\] $hrk "" hrk
            if { [set hrk [lsearch "str dex wis int con" $hrk]] == -1 } { continue }
            incr hrk
            set curdata [lreplace $curdata $hrk $hrk $num]
          }
        }
      }
    }

  }
  close $fid

  if {![array exist prof]} {
    putlog "Warning! Prof records not found."
  }
  if {![array exist race]} {
    putlog "Warning! Race records not found."
  }
}

proc mc:addfree {remort level {reset 0}} {
    set addfree [expr $remort / 10]
    if { $reset == 0 && $level <= [string index $remort end] } {
        incr addfree 1
    } elseif { $reset == 1 } {
        incr addfree [min $level [string index $remort end]]
    }
    return $addfree
}
